
#include "xbp.ch"
#include "Appevent.ch"
#include "common.ch"
#include "inkey.ch"

PROCEDURE appsys ; return
// ---------------------------------------------------------------------------

PROCEDURE Main()
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg
LOCAL lIsCentury

   SET DATE GERMAN
   SET EPOCH TO YEAR( DATE() ) - 50
   SET CENTURY OFF
   SET ALTER TO LOGFILE.TXT

   IF !FILE("DEMOPICK.DBF")
      C_DEMOPICK("DEMOPICK.DBF")
   ENDIF

   oDlg := NewForm():New(AppDesktop(),,{0,0}, {300,220},,.F.)
   oDlg:taskList := .T.
   oDlg:title    := "native DatePicker"
   oDlg:icon     := 1
   oDlg:close    := {|p1,p2,oo| IF(SP_isRun(),SP_isRun(.T.),NIL),PostAppEvent(xbeP_Quit,,,oo)}

   oDlg:Datum:autoTab     := .T.
   oDlg:Zeit:autoTab      := .T.
   oDlg:Text:autoTab      := .T.
   //
   // XppFd use 8 for Date... use CENTURY with 10
   //
   lIsCentury := SET(_SET_CENTURY)
*   IF lIsCentury
      oDlg:Datum:bufferLength := 10
*   ELSE
*      oDlg:Datum:bufferLength := 8
*   ENDIF

   oDlg:Create()

   oDlg:drawingArea:ClipChildren := .T.

#IFDEF USEPOPUP

   oDlg:oPB1:hide()
   oDlg:oPB2:hide()

   oDlg:Datum:setInputFocus := {| u1, u2, oSelf | IF(SP_isRun(),SP_isRun(.T.),NIL),oSelf:setMarked({1,oSelf:bufferLength+1}),UsePicker(oDlg:Datum,"DATE",oDlg:editControls,1)   }
   oDlg:Zeit:setInputFocus  := {| u1, u2, oSelf | IF(SP_isRun(),SP_isRun(.T.),NIL),oSelf:setMarked({1,oSelf:bufferLength+1}),UsePicker(oDlg:Zeit ,"TIME",oDlg:editControls,2)   }
   oDlg:Text:setInputFocus  := {| u1, u2, oSelf | IF(SP_isRun(),SP_isRun(.T.),NIL),oSelf:setMarked({1,oSelf:bufferLength+1})   }

   //
   // open Pop-up
   //
   oDlg:Static1:Setcaption("F4 Datum")

#ELSE

   oDlg:oPB1:activate := {|| UsePicker(oDlg:Datum,"DATE",oDlg:editControls,1,.T.)}
   oDlg:oPB2:activate := {|| UsePicker(oDlg:Zeit ,"TIME",oDlg:editControls,2)}

   oDlg:Datum:setInputFocus := {| u1, u2, oSelf | IF(SP_isRun(),SP_isRun(.T.),NIL),oSelf:setMarked({1,oSelf:bufferLength+1})   }
   oDlg:Zeit:setInputFocus  := {| u1, u2, oSelf | IF(SP_isRun(),SP_isRun(.T.),NIL),oSelf:setMarked({1,oSelf:bufferLength+1})   }
   oDlg:Text:setInputFocus  := {| u1, u2, oSelf | IF(SP_isRun(),SP_isRun(.T.),NIL),oSelf:setMarked({1,oSelf:bufferLength+1})   }

#ENDIF

   oDlg:Datum:keyBoard      := {| nKeyCode, uNIL, oSelf | MyKey(nKeyCode,oSelf,oDlg:editControls,1)   }
   oDlg:Zeit:keyBoard       := {| nKeyCode, uNIL, oSelf | MyKey(nKeyCode,oSelf,oDlg:editControls,2)   }
   oDlg:Text:keyBoard       := {| nKeyCode, uNIL, oSelf | MyKey(nKeyCode,oSelf,oDlg:editControls,3)   }

   CenterControl(oDlg)

   oDlg:Show()
   SetAppFocus( oDlg:Text )

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO
   //
   // exit STACK
   //

   oDlg:destroy()
   SET ALTER TO

RETURN

STATIC FUNCTION C_DEMOPICK(datei,alias,id)
LOCAL p,field_list:={}

  IF VALTYPE(datei)!="C"
    datei="DEMOPICK.DBF"
  ENDIF
  IF VALTYPE(alias)!="C"
    p=at(".",datei)
    alias=if(p>0,substr(datei,1,p-1),datei)
  ENDIF
  IF VALTYPE(id)!="N"
    id=0
  ENDIF
  SELECT (id)
  IF !FILE(datei)
    AADD(field_list,{"TEXT"   ,"C",10,0})
    AADD(field_list,{"DATUM"  ,"D",8,0})
    AADD(field_list,{"ZEIT"   ,"C",8,0})
    DBCREATE(datei,field_list)
  ENDIF

  USE (datei) ALIAS (alias)
  APPEND BLANK
  REPLACE DEMOPICK->TEXT  WITH "hello"
  REPLACE DEMOPICK->DATUM WITH DATE()
  REPLACE DEMOPICK->ZEIT  WITH TIME()
  CLOSE

RETURN(.t.)

STATIC FUNCTION MyKey(nKeyCode,oSelf,aEdit,nAktive)
LOCAL nNo   := 1
LOCAL iMax  := LEN(aEdit)

   DO CASE
      CASE nKeyCode = K_ESC

      CASE nKeyCode = K_ENTER
         // get data
         oSelf:getdata()

         NEXT_TAB(aEdit,nAktive,nNo)

      CASE nKeyCode = K_TAB
         NEXT_TAB(aEdit,nAktive,nNo)

      CASE nKeyCode = K_SH_TAB
         BACK_TAB(aEdit,nAktive,nNo)

   ENDCASE
RETURN NIL

CLASS NewForm FROM _NewForm
   EXPORTED:
      METHOD init
      METHOD create
ENDCLASS

METHOD NewForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::_NewForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD NewForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::_NewForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   USE DEMOPICK.DBF NEW EXCLUSIVE
   ::DEMOPICK := Select()
   AEval ( ::EditControls, { | oXbp | oXbp:SetData() } )
   ::show()

RETURN self


* Programmcode fr die Implementierungsebene der Klasse einfgen
*#include "_DEMOPICK.PRG"

//EOF
/////