#include "xbp.ch"
#include "gra.ch"
#include "os.ch"

#include "dxe_LBOX.ch"

#define COLOR_BOX_SPACING    2
#define COLOR_BOX_STRSPACING 8

PROCEDURE CreateListBox(oDlg,nVersion)
LOCAL oListBox
LOCAL oLbox    := NIL
LOCAL iMax   := 10000
LOCAL nEvery
LOCAL xScale
LOCAL i
LOCAL oDa,aPos
LOCAL aTmp
LOCAL aSize := {0,0}
LOCAL cHex
LOCAL aArray := {}
LOCAL nDiff  := 10
LOCAL nStart
LOCAL nEnd
LOCAL aMsg     := {}
LOCAL cText    := ""
LOCAL oProgress
LOCAL aPP := { { XBP_PP_COMPOUNDNAME, "24.Arial"                 },;
               { XBP_PP_BGCLR       , XBPSYSCLR_WINDOW           },;
               { XBP_PP_FGCLR       , XBPSYSCLR_WINDOWTEXT       },;
               { XBP_PP_HILITE_FGCLR, XBPSYSCLR_HILITEFOREGROUND },;
               { XBP_PP_HILITE_BGCLR, XBPSYSCLR_HILITEBACKGROUND } }

   nEvery   := INT(iMax/100)
   xScale   := iMax*nEvery

   oDa   := oDlg:drawingArea
   aTmp  := oDa:Currentsize()

   aPos  := {10,ButtonHigh}
   aSize[1] := (aTmp[1] -40)/2
   aSize[2] := aTmp[2] - ButtonHigh-nDiff                // in DXE_LBOX.CH

   oDlg:ButtonCancel:hide()

  oProgress := DXE_ProgressBar():New( oDa,, {10,2}, oDlg:ButtonCancel:Currentsize(),{{XBP_PP_BGCLR,GRA_CLR_WHITE}} )

   //
   // NEED visual Style and XP Manifest !!!
   //
   oProgress:UseVisualStyle   := .T.
   oProgress:UsePercent       := .T.
   //
   // assign after create
   //
   oProgress:Create()

   IF OnOSVersion() > 5
      oProgress:Style            := PBS_MARQUEE
   ELSE
      oProgress:Style            := PBS_SMOOTH
   ENDIF

   oProgress:Minimum          := 1
   oProgress:Maximum          := iMax
   oProgress:Increment        := nEvery
   oProgress:nScaleMax        := xScale
   oProgress:Orientation      := XBP_ORIENT_HORIZONTAL

   oProgress:Show()

// Listbox mit mehrfacher Auswahlmglichkeit erzeugen
   oListBox := XbpListbox():new( oDa,,aPos,aSize,aPP,.F.)
   oListBox:cargo := 40
   oListBox:tabStop := .T.


   DO CASE
      CASE nVersion = 0
	MsgBox("Try Parameter 1 - 5")
      CASE nVersion = 1
         oListBox:drawMode := XBP_DRAW_OWNER
         oListBox:MeasureItem := {|pos,aDim,o| IF( pos % 2 <> 0,aDim[2] := o:cargo,aDim[2] := o:cargo*2 ) }
         oListBox:drawItem    := {| oPS  , aInfo, oSelf | PureDrawItem   (oPS  , aInfo, oSelf,aPP)  }

      CASE nVersion = 2
         oListBox:drawMode := XBP_DRAW_OWNERADVANCED
         oListBox:MeasureItem := {|pos,aDim,o| IF( pos % 2 <> 0,aDim[2] := o:cargo,aDim[2] := o:cargo*2 ) }
         oListBox:drawItem    := {| oPS  , aInfo, oSelf | PureDrawItem   (oPS  , aInfo, oSelf,aPP)  }

      CASE nVersion = 3
         oListBox:drawMode := XBP_DRAW_OWNER
         oListBox:MeasureItem := {| nItem, aDims, oSelf | PureMeasureItem(nItem, aDims, oSelf,aPP)  }
         oListBox:drawItem    := {| oPS  , aInfo, oSelf | PureDrawItem   (oPS  , aInfo, oSelf,aPP)  }

      CASE nVersion = 4
         oListBox:drawMode := XBP_DRAW_OWNERADVANCED
         oListBox:MeasureItem := {| nItem, aDims, oSelf | PureMeasureItem(nItem, aDims, oSelf,aPP)  }
         oListBox:drawItem    := {| oPS  , aInfo, oSelf | PureDrawItem   (oPS  , aInfo, oSelf,aPP)  }

      CASE nVersion = 5
         oListBox:drawMode := XBP_DRAW_OWNERADVANCED
         oListBox:measureItem := {|pos,aDim,o| IF( pos % 2 <> 0,aDim[2] := o:cargo,aDim[2] := o:cargo*2 ) }
         oListBox:drawItem    := {|mp1,mp2,o| OnDrawItem(mp1,mp2,o) }


   ENDCASE
   oListBox:create()

  oProgress:SetData( 1 )                        // start here

   //
   // additem HERE
   //
   i := 1
   nStart := SECONDS()
   FOR i := 1 TO iMax
      oListBox:additem(LTRIM(STR(i)))
      FORproggress(oProgress,nEvery,i)

   NEXT
   nEnd := SECONDS() - nStart
   AADD(aMsg,"Listbox  need "+ LTRIM(STR(nEnd))+" Sec. -> "+LTRIM(STR(nEnd/(iMax),10,6))+" per aadData() " )
   oListBox:show()

// Auswahl
   oListBox:ItemSelected := {|mp1, mp2, oSelf| GetXbaseText(oSelf)  }


   aPos  := {((aTmp[1] -40)/2) +20 ,ButtonHigh}
   aSize[1] := (aTmp[1] -40)/2
   aSize[2] := aTmp[2] - ButtonHigh-nDiff                // in DXE_LBOX.CH

   //
   // native ListBox
   //
   oLbox    := DXE_ListBox():New(oDa,,aPos,aSize,aPP,.F.)
   oLbox:cargo := 40
   oLbox:tabStop := .T.

   DO CASE
      CASE nVersion = 0

      CASE nVersion = 1
         oLbox:drawMode := XBP_DRAW_OWNER
         //
         // use "internal" Method My_MeasureItem / My_drawItem
         //

      CASE nVersion = 2
         //
         // use "internal" Method My_MeasureItem / My_drawItem
         //
         oLbox:drawMode := XBP_DRAW_OWNERADVANCED

      CASE nVersion = 3
         oLbox:drawMode := XBP_DRAW_OWNER
         oLbox:MeasureItem := {| nItem, aDims, oSelf | NativeMeasureItem(nItem, aDims, oSelf)  }
         oLbox:drawItem    := {| oPS  , aInfo, oSelf | NativeDrawItem   (oPS  , aInfo, oSelf)  }

      CASE nVersion = 4
         oLbox:drawMode := XBP_DRAW_OWNERADVANCED
         oLbox:MeasureItem := {| nItem, aDims, oSelf | NativeMeasureItem(nItem, aDims, oSelf)  }
         oLbox:drawItem    := {| oPS  , aInfo, oSelf | NativeDrawItem   (oPS  , aInfo, oSelf)  }

      CASE nVersion = 5
         oLbox:drawMode := XBP_DRAW_OWNERADVANCED
         oLbox:MeasureItem := {| nItem, aDims, oSelf | NativeMeasureItem(nItem, aDims, oSelf)  }
         oLbox:drawItem    := {| oPS  , aInfo, oSelf | NativeDrawItem   (oPS  , aInfo, oSelf)  }

   ENDCASE
   oLbox:create()

   //
   // DblClick on Panel
   //
   oLbox:OnItemDblClick  := {|mp1, mp2, oSelf| GetXbaseText(oLbox)  }

  oProgress:SetData( 1 )                        // start here
   //
   // additem HERE
   //
   i := 1
   nStart := SECONDS()
   FOR i := 1 TO iMax
     oLbox:additem(LTRIM(STR(i)))
      FORproggress(oProgress,nEvery,i)
   NEXT
   nEnd := SECONDS() - nStart
   AADD(aMsg,"native   need "+ LTRIM(STR(nEnd))+" Sec. -> "+LTRIM(STR(nEnd/(iMax),10,6))+" per aadData() " )
   oLbox:show()

   //
   // NOT 2 or more "together" ... BUG
   //
*   FillBoth(oListBox,oLbox)



//   oProgress:SetData( 1 )                        // start here
//   i := 1
//   nStart := SECONDS()
//   FOR i := 1 TO iMax
//      AADD(aArray,LTRIM(STR(i)))
//   NEXT
//   //
//   // clear and add hole Array
//   //
//*  aArray :=  oLbox:_GetBigArray()
//   oLbox:Clear()
//   oLbox:_AddBigArray(aArray)
//   nEnd := SECONDS() - nStart
//   AADD(aMsg,"bigArray need "+ LTRIM(STR(nEnd))+" Sec. -> "+LTRIM(STR(nEnd/(iMax),10,6))+" per aadData() " )

   DO CASE
      CASE nVersion = 0 ; cText += "XBP_DRAW_NORMAL"
      CASE nVersion = 1 ; cText += "XBP_DRAW_OWNER, o:cargo*2"
      CASE nVersion = 2 ; cText += "XBP_DRAW_OWNERADVANCED, o:cargo*2"
      CASE nVersion = 3 ; cText += "XBP_DRAW_OWNER"
      CASE nVersion = 4 ; cText += "XBP_DRAW_OWNERADVANCED"
      CASE nVersion = 5 ; cText += "XBP_DRAW_OWNERADVANCED, OnDrawItem()"
   ENDCASE

   cText += CRLF+CRLF

   i := 1
   iMax := LEN(aMsg)
   FOR i := 1 TO iMax
      cText += aMsg[i]+CRLF
   NEXT
   Msgbox(cText,LTRIM(STR(iMax))+" Items" )

   oProgress:destroy()

   oDlg:ButtonCancel:show()

RETURN

PROCEDURE MyResize(aOldSize, aNewSize, oSelf)
LOCAL aChild := {}
LOCAL i,iMax
LOCAL nDiff  := 10

   IF aOldSize[1] == 0 .AND. aOldSize[2] == 0               // was minimize
      aOldSize := aNewSize                                  // New Size

   ELSEIF aNewSize[1] == 0 .OR. aNewSize[2] == 0            // is now minimized
      RETURN

   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN
   ENDIF                                                    // same Size

   oSelf:lockUpdate(.T.)

   aChild := oSelf:Childlist()
   iMax   := LEN(aChild )

   FOR i := 1 TO iMax
      DO CASE
         CASE aChild[i]:isDerivedFrom("XbpPushbutton")
            aChild[i]:setSize( {aNewSize[1]-45,32} )

         CASE aChild[i]:isDerivedFrom("XbpListBox")
            aChild[i]:setSize( {(aNewSize[1]-40)/2,aNewSize[2]-ButtonHigh-nDiff} )

         CASE aChild[i]:isDerivedFrom("DXE_ListBox")
            aChild[i]:setPos( {((aNewSize[1]-40)/2) +20, ButtonHigh} )
            aChild[i]:setSize( {(aNewSize[1]-40)/2,aNewSize[2]-ButtonHigh-nDiff} )

      ENDCASE
   NEXT

   oSelf:lockUpdate(.F.)
   oSelf:invalidateRect()

RETURN

FUNCTION GetXbaseText(oSelf)
LOCAL aItem := oSelf:GetData()
LOCAL cItem := ""
LOCAL i,iMax
LOCAL cText := ""

   iMax := LEN(aItem)

   IF iMax > 1
      FOR i := 1 TO iMax -1
         cItem := oSelf:GetItem( aItem[i] )
         cText += cItem +CRLF
      NEXT
      cText += oSelf:GetItem( aItem[iMax] )
   ELSE
      cText := oSelf:GetItem( aItem[1] )
   ENDIF
   msgbox(cText)

RETURN cText

PROCEDURE FillBoth(oListBox,oLbox)
LOCAL iMax   := 100
LOCAL i
LOCAL nStart := 0
LOCAL nDiff1 := 0
LOCAL nDiff2 := 0
LOCAL nVis1  := 0
LOCAL nVis2  := 0

   nStart := SECONDS()
   FOR i := 1 TO iMax
      oListBox:additem(LTRIM(STR(i)))
   NEXT
   nDiff1 := SECONDS() - nStart

   i := 1
   nStart := SECONDS()
   FOR i := 1 TO iMax
      oLbox:additem(LTRIM(STR(i)))
   NEXT
   nDiff2 := SECONDS() - nStart

*
*   MSGBOX("Xbase++ Listbox :"+STR(nDiff1)+CRLF+;
*          "native  Listbox :"+STR(nDiff2) )

RETURN

PROCEDURE NativeMeasureItem(nItem, aDims, oSelf)
//
// nItem -> Zero-based index of the list box item
// aDims -> { itemWidth, itemHeight }
//
// Note : itemWidth give strange Result ?
//
//
LOCAL cCaption
LOCAL aBox
LOCAL oPS

   //
   // get Item (Text)
   //
   cCaption := oSelf:GetItem( nItem )

   oPS      := oSelf:LockPS()
   //
   // set Font before
   //
   GraSetFont( oPS, oSelf:oFont )
   //
   // GraQueryTextBox() Dimension
   //
   aBox     := GraQueryTextBox( oPS, cCaption )

   //
   // wide of Item (Text)
   //
   aDims[1] := aBox[3][1] - aBox[1][1]
   //
   // heigh of Item (Text)
   //
   aDims[2] := oSelf:GetItemsHeight( nItem )

   IF oSelf:drawMode <> XBP_DRAW_NORMAL
      //
      // need to calculate from aBox
      //
      aDims[2] := aBox[1][2] - aBox[2][2]
   ENDIF

   IF oSelf:drawMode = XBP_DRAW_OWNERADVANCED
      //
      // just playing
      //
      IF ( nItem % 2) <> 0
         aDims[2] := aDims[2] * 2
      ENDIF
   ENDIF

   oSelf:UnlockPS()

   onDummy("NativeMeasureItem",nItem, cCaption,aDims)

RETURN

PROCEDURE NativeDrawItem(oPS, aInfo, oSelf)
LOCAL aAAttrs  := Array( GRA_AA_COUNT )
LOCAL aSAttrs  := Array( GRA_AS_COUNT )
LOCAL aPrev
LOCAL cText
*LOCAL nHDC    := 0
LOCAL nXDest   := aInfo[XBP_DRAWINFO_RECT][1]
LOCAL nYDest   := aInfo[XBP_DRAWINFO_RECT][2]
LOCAL nWidth   := aInfo[XBP_DRAWINFO_RECT][3]
LOCAL nHeight  := aInfo[XBP_DRAWINFO_RECT][4]
LOCAL cFile

   //
   // set Font before
   //
   GraSetFont( oPS, oSelf:oFont )
   //
   // get Item (Text)
   //
   cText := oSelf:GetItem(aInfo[XBP_DRAWINFO_ITEM])


   IF BAND(aInfo[XBP_DRAWINFO_STATE],XBP_DRAWSTATE_SELECTED) != 0
      aAAttrs[GRA_AA_COLOR] := XBPSYSCLR_HILITEBACKGROUND
   ELSE
      aAAttrs[GRA_AA_COLOR] := XBPSYSCLR_WINDOW
   ENDIF

   //
   // this calculation is different to Xbase++ !!!
   //
   // it is while i "simulate" oPS with ViewPoint 0,0
   // to use GRA Function
   //

   nWidth   := nWidth  - nXDest
   nHeight  := nHeight - nYDest
   nXDest   := 0
   nYDest   := 0

   //
   // fill Background ( of Bitmap inside oPS )
   //
   GraSetAttrArea( oPS, aAAttrs )
   GraBox( oPS, {nXDest,nYDest}, {nWidth,nHeight}, GRA_FILL )

   //
   // Colorbox ala Pablo
   //
   nHeight  -= COLOR_BOX_SPACING *2

   aAAttrs[GRA_AA_COLOR] := 0x01800000   + aInfo[XBP_DRAWINFO_ITEM] * oSelf:cargo
   GraSetAttrArea( oPS, aAAttrs )
   GraBox( oPS, {nXDest+ COLOR_BOX_SPACING,nYDest+ COLOR_BOX_SPACING},;
                {16,nHeight}, GRA_OUTLINEFILL )



   //
   // Text
   //
   aSAttrs[GRA_AS_COLOR]     := GRA_CLR_PINK
   aSAttrs[GRA_AS_VERTALIGN] := GRA_VALIGN_HALF
   aPrev                     := GraSetAttrString( oPS, aSAttrs )

   GraCaptionStr(oPS, {nXDest+16+COLOR_BOX_STRSPACING,nYDest } ,;
                      {nWidth,nHeight} ,;
                       cText           ,;
                       XBPALIGN_VCENTER  )

   GraSetAttrString( oPS, aPrev )

   IF Band(aInfo[XBP_DRAWINFO_STATE], XBP_DRAWSTATE_FOCUS) != 0
      GraFocusRect( oPS, {nXDest,nYDest},{nWidth,nHeight} )
   ENDIF


   onDummy("NativeDrawItem   ",aInfo[XBP_DRAWINFO_ITEM],cText,;
           "{"+LTRIM(STR(nXDest ))+","+;
               LTRIM(STR(nYDest ))+","+;
               LTRIM(STR(nWidth ))+","+;
               LTRIM(STR(nHeight))+"}" )

RETURN

PROCEDURE PureMeasureItem(nItem, aDims, oSelf,aPP)
//
// nItem -> Zero-based index of the list box item
// aDims -> { itemWidth, itemHeight }
//
// Note : itemWidth give strange Result ?
//
//
LOCAL cCaption
LOCAL aBox
LOCAL oPS
LOCAL nPosi

STATIC oFont := NIL

   IF NIL = oFont
      nPosi := ASCAN(aPP,{|x| x[1] = XBP_PP_COMPOUNDNAME } )
      IF nPosi > 0
         oFont  := xbpFont():new()        // Font-Objekt und
         oFont:create()                   // Font erzeugen
         oFont:configure( aPP[nPosi][2] )
      ENDIF
   ENDIF

   //
   // get Item (Text)
   //
   cCaption := oSelf:GetItem( nItem )

   oPS      := oSelf:LockPS()
   //
   // set Font before
   //
   GraSetFont( oPS, oFont )
   //
   // GraQueryTextBox() Dimension
   //
   aBox     := GraQueryTextBox( oPS, cCaption )

   //
   // wide of Item (Text)
   //
   aDims[1] := aBox[3][1] - aBox[1][1]
   //
   // heigh of Item (Text)
   //
   aDims[2] := oSelf:GetItemsHeight( nItem )

   IF oSelf:drawMode <> XBP_DRAW_NORMAL
      //
      // need to calculate from aBox
      //
      aDims[2] := aBox[1][2] - aBox[2][2]
   ENDIF

   IF oSelf:drawMode = XBP_DRAW_OWNERADVANCED
      //
      // just playing
      //
      IF ( nItem % 2) <> 0
         aDims[2] := aDims[2] * 2
      ENDIF
   ENDIF

   oSelf:UnlockPS()

   onDummy("PureMeasureItem  ",nItem, cCaption,aDims)

RETURN

PROCEDURE PureDrawItem(oPS, aInfo, oSelf,aPP)
LOCAL aSAttrs  := Array( GRA_AS_COUNT )
LOCAL aAAttrs  := Array( GRA_AA_COUNT )
LOCAL aPrev
LOCAL cText
LOCAL nXDest   := aInfo[XBP_DRAWINFO_RECT][1]
LOCAL nYDest   := aInfo[XBP_DRAWINFO_RECT][2]
LOCAL nWidth   := aInfo[XBP_DRAWINFO_RECT][3]
LOCAL nHeight  := aInfo[XBP_DRAWINFO_RECT][4]
LOCAL nPosi

*STATIC oFont := NIL
*   IF NIL = oFont
*      nPosi := ASCAN(aPP,{|x| x[1] = XBP_PP_COMPOUNDNAME } )
*      IF nPosi > 0
*         oFont  := xbpFont():new()        // Font-Objekt und
*         oFont:create()                   // Font erzeugen
*         oFont:configure( aPP[nPosi][2] )
*      ENDIF
*   ENDIF
*   GraSetFont( oPS, oFont )

   IF BAND(aInfo[XBP_DRAWINFO_STATE],XBP_DRAWSTATE_SELECTED) != 0
      aAAttrs[GRA_AA_COLOR] := XBPSYSCLR_HILITEBACKGROUND
   ELSE
      aAAttrs[GRA_AA_COLOR] := XBPSYSCLR_WINDOW
   ENDIF

   GraSetAttrArea( oPS, aAAttrs )
   GraBox( oPS, {nXDest,nYDest}, {nWidth,nHeight}, GRA_FILL )


   //
   // Draw the caption
   //
   aSAttrs[GRA_AS_COLOR]     := GRA_CLR_BLUE
   aSAttrs[GRA_AS_VERTALIGN] := GRA_VALIGN_HALF
   aPrev                     := GraSetAttrString( oPS, aSAttrs )

   cText := oSelf:GetItem(aInfo[XBP_DRAWINFO_ITEM])


*   GraStringAt( oPS, {nXDest,nYDest},cText )

   GraCaptionStr(oPS, {nXDest,nYDest } ,;
                      {nWidth,nHeight} ,;
                       cText           ,;
                       XBPALIGN_VCENTER  )

   GraSetAttrString( oPS, aPrev )

   //
   // Draw the focus box, if the object
   // has the input focus
   //
   IF Band(aInfo[XBP_DRAWINFO_STATE], XBP_DRAWSTATE_FOCUS) != 0
      GraFocusRect( oPS, {nXDest,nYDest},{nWidth,nHeight} )
   ENDIF

   onDummy("PureDrawItem     ",aInfo[XBP_DRAWINFO_ITEM],cText,;
           "{"+LTRIM(STR(nXDest ))+","+;
               LTRIM(STR(nYDest ))+","+;
               LTRIM(STR(nWidth ))+","+;
               LTRIM(STR(nHeight))+"}" )

RETURN

STATIC FUNCTION OnDrawItem( mp1, mp2 , oXbp)

   LOCAL aPosStart
   LOCAL aPosEnd
   LOCAL aAreaAttrs   := Array( GRA_AA_COUNT )
   LOCAL aAreaAttrs2  := Array( GRA_AA_COUNT )
   LOCAL aStringAttrs := Array( GRA_AS_COUNT )
   LOCAL oFont
   LOCAL nItem
   LOCAL nHeight      := mp2[4][4] - mp2[4][2] - COLOR_BOX_SPACING *2


   // Select background color depending on
   // the item's selection state and render
   // the background. Selected items are
   // rendered using a special background
   // color.
   IF BAND(mp2[3],XBP_DRAWSTATE_SELECTED) != 0
      aAreaAttrs2[GRA_AA_COLOR] := XBPSYSCLR_HILITEBACKGROUND
   ELSE
      aAreaAttrs2[GRA_AA_COLOR] := XBPSYSCLR_WINDOW
   ENDIF

   GraSetAttrArea( mp1, aAreaAttrs2 )
   GraBox( mp1, {mp2[4][1],mp2[4][2]}, {mp2[4][3],mp2[4][4]}, GRA_FILL )

   // Draw a focus rectangle if the listbox
   // currently has the input focus.
   IF BAND(mp2[3],XBP_DRAWSTATE_FOCUS) != 0
      mp1:drawFocusRect( {mp2[4][1],mp2[4][2]},{mp2[4][3],mp2[4][4]}   )
   ENDIF

   // Draw a colored rectangle and output the
   // name of the color next to it.
   IF mp2[1] == 0
      return NIL
   ENDIF

   aPosStart := {mp2[4][1]    + COLOR_BOX_SPACING, ;
                 mp2[4][2]    + COLOR_BOX_SPACING}
   aPosEnd   := {aPosStart[1] + 16,   ;
                 aPosStart[2] + nHeight }

   aAreaAttrs[GRA_AA_COLOR] := 0x01800000   + mp2[1] * oXbp:cargo
   GraSetAttrArea( mp1, aAreaAttrs )
   GraBox( mp1, aPosStart, aPosEnd, GRA_OUTLINEFILL )

   aPosStart[1] := aPosEnd[1] + COLOR_BOX_STRSPACING
   aPosStart[2] += (aPosEnd[2] - aPosStart[2]) /2

   IF BAND(mp2[3],XBP_DRAWSTATE_DISABLED) != 0
      aStringAttrs[GRA_AS_COLOR] := XBPSYSCLR_INACTIVETITLETEXT
   ELSEIF BAND(mp2[3],XBP_DRAWSTATE_SELECTED) != 0
      aStringAttrs[GRA_AS_COLOR] := XBPSYSCLR_WINDOW
   ENDIF
   aStringAttrs[GRA_AS_VERTALIGN] := GRA_VALIGN_HALF
   GraSetAttrString( mp1, aStringAttrs )

   oFont := oXbp:SetFont()
   IF oFont != NIL
      GraSetFont( mp1, oFont )
   ENDIF

   GraStringAt( mp1, aPosStart, StrZero(mp2[1], 3) )



return NIL


STATIC FUNCTION FORproggress(oProgress,nEvery,i)
LOCAL nValue := i
   IF ((nValue) % (nEvery)) == 0
*      oProgress:StepIt()
      nValue := oProgress:GetData()
      nValue += nEvery
      oProgress:SetData( nValue )

      onDummy("FORproggress",nValue,nEvery)

   ENDIF
RETURN .T.


STATIC FUNCTION OnOSVersion()
LOCAL cVersion := OS(OS_VERSION)
LOCAL nVersion := 0
LOCAL nPosi

   nPosi := AT(".",cVersion)
   IF nPosi > 0
      nVersion := VAL(SUBSTR(cVersion,1,nPosi-1))
   ELSE
   ENDIF

RETURN nVersion

STATIC PROCEDURE onDummy()
#IFDEF DEBUGME
LOCAL iMax := PCount()
LOCAL i
LOCAL cText := ""
LOCAL xValue

*ALTD()

   FOR i := 1 TO iMax -1
      cText += Var2Char( PValue( i ) ) + CHR(9)
   NEXT
   cText += Var2Char( PValue( iMax ) )

   SET CONSOLE OFF
   SET ALTER ON

   IF EMPTY(cText)
      ? " "+CRLF
   ELSE
      ? cText
   ENDIF
   SET ALTER OFF
   SET CONSOLE ON

#ENDIF

RETURN

*
* EOF
*