#include "xbp.ch"
#include "gra.ch"

#include "dxe_LBOX.ch"

PROCEDURE CreateListBox(oDlg)
LOCAL oDriveBox
LOCAL oDirBox    := NIL
LOCAL oDa,aPos
LOCAL aTmp
LOCAL aSize := {0,0}
LOCAL cHex
LOCAL aArray := {}
LOCAL nDiff  := 10
LOCAL aPP := { { XBP_PP_COMPOUNDNAME, "20.Arial"                 },;
               { XBP_PP_BGCLR       , XBPSYSCLR_WINDOW           },;
               { XBP_PP_FGCLR       , XBPSYSCLR_WINDOWTEXT       },;
               { XBP_PP_HILITE_FGCLR, XBPSYSCLR_HILITEFOREGROUND },;
               { XBP_PP_HILITE_BGCLR, XBPSYSCLR_HILITEBACKGROUND } }

   oDa   := oDlg:drawingArea
   aTmp  := oDa:Currentsize()

   aPos  := {10,ButtonHigh}
   aSize[1] := (aTmp[1] -40)/2
   aSize[2] := aTmp[2] - ButtonHigh-nDiff                // in DXE_LBOX.CH

**********************************************************************
*
*  show Drives with Icon
*
**********************************************************************

   oDriveBox := DXE_Listbox():new(oDa ,,aPos,aSize,aPP)
   oDriveBox:DrawMode := XBP_DRAW_OWNERADVANCED
   oDriveBox:MeasureItem := {| nItem, aDims, oSelf | P_MeasureItem(nItem, aDims, oSelf)  }
   oDriveBox:drawItem    := {| oPS  , aInfo, oSelf | P_drawItem   (oPS  , aInfo, oSelf)  }
   oDriveBox:create()

*  oDriveBox:SortMode    := .T.
   //
   // set Size
   //
   oDriveBox:nIconSize   := 32
   //
   // init System ImageList
   //
   oDriveBox:InitImageList()
   oDriveBox:show()
   //
   // DblClick on Panel
   //
   oDriveBox:OnItemDblClick := {|o,st| GetXbaseText(oDriveBox) }

   //
   // fill Listbox with Drive
   //
   oDriveBox:Startdir("C:\","DRIVE",oDriveBox:hXbp)


**********************************************************************
*
*  show Directory with Icon
*
**********************************************************************

   aPos  := {((aTmp[1] -40)/2) +20 ,ButtonHigh}
   aSize[1] := (aTmp[1] -40)/2
   aSize[2] := aTmp[2] - ButtonHigh-nDiff                // in DXE_LBOX.CH

   //
   // native ListBox
   //
   oDirBox := DXE_ListBox():New(oDa,,aPos,aSize,aPP,.F.)
   oDirBox:DrawMode    := XBP_DRAW_OWNERADVANCED
   oDirBox:MeasureItem   := {| nItem, aDims, oSelf | P_MeasureItem(nItem, aDims, oSelf)  }
   oDirBox:drawItem      := {| oPS  , aInfo, oSelf | P_drawItem   (oPS  , aInfo, oSelf)  }
   oDirBox:create()

*   oDirBox:SortMode     := .T.
   //
   // set Size
   //
   oDirBox:nIconSize   := 32
   //
   // init System ImageList
   //
   oDirBox:InitImageList()

   oDirBox:show()
   //
   // DblClick on Panel
   //
   oDirBox:OnItemDblClick   := {|o,st| GetXbaseText(oDirBox  ) }

   //
   // fill Listbox with Directory
   //
   oDirBox:Startdir( ,"DIR")

RETURN


PROCEDURE MyResize(aOldSize, aNewSize, oSelf)
LOCAL aChild := {}
LOCAL i,iMax
LOCAL nDiff  := 10

   IF aOldSize[1] == 0 .AND. aOldSize[2] == 0               // was minimize
      aOldSize := aNewSize                                  // New Size

   ELSEIF aNewSize[1] == 0 .OR. aNewSize[2] == 0            // is now minimized
      RETURN

   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN
   ENDIF                                                    // same Size

   oSelf:lockUpdate(.T.)

   aChild := oSelf:Childlist()
   iMax   := LEN(aChild )

   FOR i := 1 TO iMax
      DO CASE
         CASE aChild[i]:isDerivedFrom("XbpPushbutton")
            aChild[i]:setSize( {aNewSize[1]-45,32} )

         CASE ( aChild[i]:isDerivedFrom("DXE_ListBox") .or. ;
                aChild[i]:isDerivedFrom("XbpListBox") ).AND. i = 2

            aChild[i]:setSize( {(aNewSize[1]-40)/2,aNewSize[2]-ButtonHigh-nDiff} )

         CASE aChild[i]:isDerivedFrom("DXE_ListBox") .AND. i = 3
            aChild[i]:setPos( {((aNewSize[1]-40)/2) +20, ButtonHigh} )
            aChild[i]:setSize( {(aNewSize[1]-40)/2,aNewSize[2]-ButtonHigh-nDiff} )

      ENDCASE
   NEXT

   oSelf:lockUpdate(.F.)
   oSelf:invalidateRect()

RETURN

FUNCTION GetXbaseText(oSelf)
LOCAL aItem := oSelf:GetData()
LOCAL cItem := ""
LOCAL i,iMax
LOCAL cText := ""

LOCAL cNewPath
LOCAL cPath
LOCAL cExt

   iMax := LEN(aItem)

   IF iMax > 1
      FOR i := 1 TO iMax -1
         cItem := oSelf:GetItem( aItem[i] )
         cText += cItem +CRLF
      NEXT
      cText += oSelf:GetItem( aItem[iMax] )

      msgbox(cText)
   ELSE
      cText := oSelf:GetItem( aItem[iMax] )

       IF ( "[" $ cText .AND. "]" $ cText  )

         cText := StrTran( cText, "[", "" )
         cText := StrTran( cText, "]", "" )

         cPath := oSelf:GetFullPath()
         cExt  := oSelf:GetExtension()

         IF cExt == "."                      // Current directory is selected

         ELSEIF cExt == ".."                 // Parent directory is selected

            cNewPath := oSelf:UpPath(cPath)
            cNewPath += "\"+cExt
            oSelf:Startdir(cNewPath,"DIR")

         ELSE

            cNewPath := cPath+ALLTRIM(cText)
            cNewPath += "\"+cExt
            oSelf:Startdir(cNewPath,"DIR")

         ENDIF

      ELSE
         msgbox(cText)
      ENDIF

   ENDIF

RETURN cText


PROCEDURE P_MeasureItem(nItem, aDims, oSelf)
//
// nItem -> Zero-based index of the list box item
// aDims -> { itemWidth, itemHeight }
//
// Note : itemWidth give strange Result ?
//
//
LOCAL cCaption
LOCAL aBox
LOCAL oPS

   cCaption := oSelf:GetItem( nItem )

   oPS      := oSelf:LockPS()
   GraSetFont( oPS, oSelf:oFont )
   aBox     := GraQueryTextBox( oPS, cCaption )

   aDims[1] := aBox[3][1] - aBox[1][1]
   aDims[2] := oSelf:GetItemsHeight( nItem )

   IF oSelf:drawMode <> XBP_DRAW_NORMAL
      //
      // need to calculate from aBox
      //
      aDims[2] := aBox[1][2] - aBox[2][2]

      IF oSelf:drawMode = XBP_DRAW_OWNERADVANCED
         //
         // just playing
         //
         IF ( nItem % 2) <> 0
*            aDims[2] := aDims[2] * 2
         ENDIF
      ENDIF
   ENDIF


   oSelf:UnlockPS()

RETURN

PROCEDURE P_drawItem(oPS, aInfo, oSelf)
LOCAL aAAttrs  := Array( GRA_AA_COUNT )
LOCAL aSAttrs  := Array( GRA_AS_COUNT )
LOCAL aPrev
LOCAL cText
LOCAL nXDest   := aInfo[XBP_DRAWINFO_RECT][1]
LOCAL nYDest   := aInfo[XBP_DRAWINFO_RECT][2]
LOCAL nWidth   := aInfo[XBP_DRAWINFO_RECT][3]
LOCAL nHeight  := aInfo[XBP_DRAWINFO_RECT][4]
LOCAL cFile
LOCAL oIcon
LOCAL nBmpSize := nHeight - nYDest

   GraSetFont( oPS, oSelf:oFont )

   //
   // Note : second Parameter aInfo[XBP_DRAWINFO_HWND]
   //
   cText := oSelf:GetItem(aInfo[1],aInfo[XBP_DRAWINFO_HWND])

   //
   // get System Icon
   //
   oIcon  := oSelf:OneImageFile(oSelf:cUsePath+cText)

   IF BAND(aInfo[3],XBP_DRAWSTATE_SELECTED) != 0
      aAAttrs[GRA_AA_COLOR]  := oSelf:lv_OD_HILITEBACKGROUND
   ELSE
      aAAttrs[GRA_AA_COLOR]  := oSelf:lv_OD_SetBkColor
   ENDIF


   nWidth   := nWidth  - nXDest
   nHeight  := nHeight - nYDest
   nXDest   := 0
   nYDest   := 0

   GraSetAttrArea( oPS, aAAttrs )
   GraBox( oPS, {nXDest,nYDest}, {nWidth,nHeight}, GRA_FILL )


*  oIcon:Draw( oPS, {0,0,nBmpSize,nBmpSize},,,GRA_BLT_BBO_IGNORE )
   oIcon:Draw( oPS, {0,0,nBmpSize,nBmpSize},,,4 )

   aSAttrs[GRA_AS_COLOR]     := oSelf:lv_OD_SetTextColor
   aSAttrs[GRA_AS_VERTALIGN] := GRA_VALIGN_HALF
   aPrev                     := GraSetAttrString( oPS, aSAttrs )

   nXDest   := nBmpSize +2

   GraCaptionStr(oPS, {nXDest,nYDest } ,;
                      {nWidth,nHeight} ,;
                       cText           ,;
                       XBPALIGN_VCENTER  )

   GraSetAttrString( oPS, aPrev )

   IF Band(aInfo[3], XBP_DRAWSTATE_FOCUS) != 0
      GraFocusRect( oPS, {nXDest,nYDest},{nWidth,nHeight} )
   ENDIF

RETURN




*
* EOF
*