
#include "Xbp.ch"
#include "Appevent.ch"
#include "Gra.CH"

//
// missing in ot4xb.ch
//
#Define PBST_NORMAL        0x0001
#Define PBST_ERROR         0x0002
#Define PBST_PAUSED        0x0003

*#include "CommCtrl_constants.ch"
// use ot4xb Constante
#define PBS_MARQUEE       0x08
#define PBS_SMOOTH        0x01

//////////////////////////////////////////////////////////////////////
//
//  TEST.PRG
//
//  Copyright:
//      Alaska Software, (c) 2002-2010. All rights reserved.
//
//  Contents: This file contains the code for a sample application
//            that illustrates usage of the XbpProgressBar
//
//
//  modify for ot4xb DXE_ProgressBar() by Auge & Ohr, Jimmy
//
//////////////////////////////////////////////////////////////////////

#Define PBS_NORMAL         0

#define ID_oObj            1  // Progressbar Object
#define ID_oRun            2  // Thread      Object
#define ID_aPos            3  // Progressbar Position
#define ID_aSize           4  // Progressbar Size
#define ID_nMax            5  // Progressbar Scale Maximum
#define ID_nStyle          6  // Progressbar PBS_ Style
#define ID_lVisual         7  // UseVisualStyle
#define ID_lPercent        8  // Show Percent
#define ID_nError          9  // change to Error Color (RED) when reach
#define ID_nPause          10 // change to Pause Color (YELLOW) when reach
#define ID_aPP             11 // Presentation Parameter

PROCEDURE AppSys()
RETURN

PROCEDURE Main()
LOCAL oDlg
LOCAL nEvent := 0, mp1 := 0, mp2 := 0
LOCAL bBlock, oXbp
LOCAL obp1,obp2,obp3

//
//
// use Array for Information
//
// Array Element look at #define ID_ Constante
//
//
LOCAL aArray   := { {NIL,NIL,{ 40,130},{300,50},100,PBS_SMOOTH ,.T.,.T.,33,66,{}},;
                    {NIL,NIL,{ 40,200},{300,50},100,PBS_MARQUEE,.T.,.F.,-1,-1,{}},;
                    {NIL,NIL,{ 40,270},{300,50},100,PBS_SMOOTH ,.F.,.T.,33,66,{{XBP_PP_BGCLR,GRA_CLR_BLUE},{ XBP_PP_FGCLR,GRA_CLR_PINK },{XBPSYSCLR_HILITEFOREGROUND,GRA_CLR_WHITE},{XBPSYSCLR_HILITEBACKGROUND,GRA_CLR_GREEN}} },;
                    {NIL,NIL,{ 40,340},{300,50},100,PBS_NORMAL ,.F.,.T.,33,66,{{XBP_PP_BGCLR,GRA_CLR_CYAN},{ XBP_PP_FGCLR,GRA_CLR_PINK },{XBPSYSCLR_HILITEFOREGROUND,GRA_CLR_WHITE}} },;
                    {NIL,NIL,{380,130},{50,300},100,PBS_SMOOTH ,.T.,.T.,33,66,{}},;
                    {NIL,NIL,{440,130},{50,300},100,PBS_MARQUEE,.T.,.T.,-1,-1,{}},;
                    {NIL,NIL,{500,130},{50,300},100,PBS_SMOOTH ,.F.,.T.,33,66,{{XBP_PP_BGCLR,GRA_CLR_BLUE},{ XBP_PP_FGCLR,GRA_CLR_CYAN }} },;
                    {NIL,NIL,{560,130},{50,300},100,PBS_NORMAL ,.F.,.T.,33,66,{{XBP_PP_BGCLR,GRA_CLR_CYAN},{ XBP_PP_FGCLR,GRA_CLR_RED  }} } }

   oDlg := XbpDialog():New( AppDesktop() )
   oDlg:Title       := "native XbpProgressBar"
   oDlg:TaskList    := .T.
   oDlg:icon        := 1
   oDlg:Create( ,,,{640,480},, .F. )

   CenterControl( oDlg )
   oDlg:Show()
   SetAppFocus( oDlg )

   obp1 := XbpPushButton():new(oDlg:DrawingArea, , {10, 4}, {610,30} )
   obp1:caption := "Exit"
   obp1:create()
   obp1:activate:= {|| PostAppEvent(xbeP_Close) }

   obp2 := XbpPushButton():new(oDlg:DrawingArea, , {10,36}, {610,30} )
   obp2:caption := "Pause"
   obp2:create()
   obp2:activate:= {|| PauseShow(oDlg,aArray) }

   obp3 := XbpPushButton():new(oDlg:DrawingArea, , {10,68}, {610,30} )
   obp3:caption := "Color"
   obp3:create()
   obp3:activate:= {|| StartCreate(oDlg,aArray)  }

   StartCreate(oDlg,aArray)

   SetAppFocus( obp3 )

   nEvent := xbeP_None
   DO WHILE nEvent != xbeP_Close
      nEvent := AppEvent( @mp1, @mp2, @oXbp )

      IF (bBlock := SetAppEvent(nEvent)) <> NIL
         Eval( bBlock, mp1, mp2, oXbp )
      ELSE
         oXbp:HandleEvent( nEvent, mp1, mp2 )
      ENDIF
   ENDDO

   //
   // stop all Threads
   //
   StopShow(aArray)

RETURN

PROCEDURE StartCreate(oDlg,aArray)
LOCAL i,iMax
LOCAL aPP
LOCAL lColor

   //
   // stop all Threads
   //
   lColor := StopShow(aArray)

   iMax := LEN(aArray)
   FOR i := 1 TO iMax
      IF lColor = .T.
         aPP := aArray[i][ ID_aPP ]
         IF !EMPTY(aPP)
            //
            // Random Xbase++ GRA_CLR_* Color
            //
            aArray[i][ ID_aPP ] := { {XBP_PP_BGCLR,RandomInt(0, 15) } ,;
                                     {XBP_PP_FGCLR,RandomInt(0, 15) }  }

         ENDIF
      ENDIF
      //
      // now crate Thread
      //
      CreateProgressThread(oDlg,aArray[i])
   NEXT
RETURN

FUNCTION StopShow(aArray)
LOCAL i,iMax
LOCAL oObj
LOCAL oRun
LOCAL lRet := .F.

   iMax := LEN(aArray)
   FOR i := 1 TO iMax
      oObj := aArray[i][ ID_oObj ]
      oRun := aArray[i][ ID_oRun ]

      IF oRun <> NIL
         //
         // :SetInterval( NIL ) to stop a Thread
         //
         oRun:SetInterval( NIL )
         oObj:destroy()
         lRet := .T.
      ENDIF
   NEXT

RETURN lRet

PROCEDURE PauseShow(oDlg,aArray)
LOCAL i,iMax
LOCAL oObj
LOCAL oRun
LOCAL nStyle

STATIC isRun := .T.
STATIC nOldSpeed := 0

   IF isRun == .T.
      isRun := .F.
   ELSE
      isRun := .T.
   ENDIF

   iMax := LEN(aArray)
   FOR i := 1 TO iMax
      oObj   := aArray[i][ ID_oObj   ]
      oRun   := aArray[i][ ID_oRun   ]
      nStyle := aArray[i][ ID_nStyle ]

      IF oRun <> NIL
         IF isRun == .F.
            //
            // set big Interval
            //
            oRun:SetInterval( 1000000 )
            IF nStyle = PBS_MARQUEE
               nOldSpeed := oObj:GetMarqueeSpeed()
               //
               // "stop" Marquee
               //
               oObj:SetMarqueeSpeed( -1 )
            ENDIF
         ELSE
            //
            // new Random Interval
            //
            oRun:SetInterval( RandomInt(10, 50) )
            IF nStyle = PBS_MARQUEE
               IF nOldSpeed <> 0
                  oObj:SetMarqueeSpeed( nOldSpeed )
               ELSE
                  oObj:SetMarqueeSpeed(  1 )
               ENDIF
            ENDIF
         ENDIF
      ENDIF
   NEXT
RETURN


PROCEDURE CreateProgressThread( oDlg, aItem)
LOCAL oProgress
LOCAL oThread
//
// modify for DXE_ProgressBar()
//
LOCAL oObj     := aItem[ ID_oObj     ]
LOCAL oRun     := aItem[ ID_oRun     ]
LOCAL aPos     := aItem[ ID_aPos     ]
LOCAL aSize    := aItem[ ID_aSize    ]
LOCAL nMax     := aItem[ ID_nMax     ]
LOCAL nStyle   := aItem[ ID_nStyle   ]
LOCAL lVisual  := aItem[ ID_lVisual  ]
LOCAL lPercent := aItem[ ID_lPercent ]
LOCAL nError
LOCAL nPause
LOCAL aPP      := aItem[ ID_aPP      ]

   oProgress := DXE_ProgressBar():New( oDlg:DrawingArea,, aPOS, aSIZE,aPP )
   //
   // these Option must be set before create()
   //
   oProgress:UseVisualStyle := lVisual
   oProgress:UsePercent     := lPercent
   //
   oProgress:Create()

   //
   // set Style after create()
   //
   oProgress:Style   := nStyle

   IF nStyle = PBS_MARQUEE
      //
      // make faster
      //
      oProgress:SetMarqueeSpeed( 10 )
   ENDIF


#IFDEF UseRandom
   oProgress:Minimum := 0
   oProgress:Maximum := RandomInt( 0, nMax ) + 1

   oProgress:SetData( RandomInt( oProgress:Maximum) )

   nPause :=  RandomInt(  oProgress:Maximum/3   ,(oProgress:Maximum/3)*2 )
   nError :=  RandomInt( (oProgress:Maximum/3)*2, oProgress:Maximum      )

#ELSE

   oProgress:Minimum := 0
   oProgress:Maximum := 100

   //
   // when use Marquee Effect do NOT switch oProgress:State
   // it will "slow down" (???) Marquee Effect on Win7
   //
   nPause := IF(aItem[ ID_nError ]<0,oProgress:Maximum+1,aItem[ ID_nError ])
   nError := IF(aItem[ ID_nPause ]<0,oProgress:Maximum+1,aItem[ ID_nPause ])

   //
   // Percent Calculation based on default 100 = %
   //
   // o:Maximum := 400 -> o:nScaleMax := 1000
   //
   oProgress:nScaleMax  := 100
#ENDIF

   oThread := Thread():New()
   //
   // use Random Interval for each Thread
   //
   oThread:SetInterval( RandomInt(10, 50) )
   oThread:Start( {|| ProgressThreadFunc(oProgress,nPause,nError)} )

   //
   // assign to Array
   //
   aItem[ ID_oObj ] := oProgress
   aItem[ ID_oRun ] := oThread

RETURN

PROCEDURE ProgressThreadFunc( oProgress, nPause, nError )
LOCAL nValue := oProgress:GetData()

   nValue++

   IF nValue >= oProgress:Maximum
      nValue := oProgress:Minimum
   ENDIF

   IF oProgress:IsMarquee()
      //
      // do not switch oProgress:State
      //
   ELSE
      DO CASE
         CASE nValue >= nError
            //
            // Color RED
            //
            oProgress:State := PBST_ERROR

         CASE nValue >= nPause .AND. nValue < nError
            //
            // Color YELLOW
            //
            oProgress:State := PBST_PAUSED

         OTHERWISE
            //
            // Color GREEN
            //
            oProgress:State := PBST_NORMAL
      ENDCASE
   ENDIF
   oProgress:SetData( nValue )

RETURN

*
*
*