
#include "xbp.ch"
#include "Appevent.ch"
#include "common.ch"
#include "inkey.ch"
#include "gra.ch"

#include "ot4xb.ch"

#DEFINE xtpSkinApplyMetrics   1
#DEFINE xtpSkinApplyFrame     2
#DEFINE xtpSkinApplyColors    4
#DEFINE xtpSkinApplyMenus     8

#IFDEF UseDXE
   #include "dxe_Rbar.ch"
   #include "DLL.ch"
   DLLFUNCTION GetModuleHandleA( cModule ) USING STDCALL FROM KERNEL32.DLL
#ENDIF

*#DEFINE UseColor  .T.
*#DEFINE UseSkin   .T.

#PRAGMA LIBRARY( "ASCOM10.LIB" )

PROCEDURE appsys ; return
// ---------------------------------------------------------------------------

PROCEDURE Main()
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg
LOCAL oSkin
LOCAL aSize := {630,480}

   SET DATE GERMAN
   SET CENTURY ON
   SET ALTER TO LOGFILE2.TXT

   oDlg := TbDialog():New(AppDesktop(),,{0,0}, aSize,,.F.)

   oDlg:taskList := .T.
   oDlg:title    := "native Rebar with Toolbar"
   oDlg:icon     := 1
   oDlg:close    := {|p1,p2,oo| PostAppEvent(xbeP_Quit,,,oo) }
   oDlg:drawingArea:resize := {| aOldSize, aNewSize, oSelf | MyResize(aOldSize,aNewSize,oSelf,oDlg)  }
   oDlg:drawingArea:ClipChildren := .T.
   oDlg:Create()
#IFDEF UseColor
*  oDlg:drawingArea:setcolorBG( GraMakeRGBColor({255,242,229}) )
   oDlg:drawingArea:setcolorBG( GraMakeRGBColor({202,228,254}) )
#ENDIF

#IFDEF UseSkin
   oSkin := XbpActiveXControl():new(oDlg:drawingArea, , {0,0}, {0,0} )
   oSkin:CLSID := "{16378D39-12CF-4C7D-8769-DFAAF02FD1F5}"
   oSkin:License := "Skin Framework Control Copyright (c) 2003-2009 Codejock Software"+ Chr(13)+Chr(10) +;
      "PRODUCT-ID: Codejock.SkinFramework.ActiveX.v13.0"+ Chr(13)+Chr(10) +;
      "VALIDATE-CODE: GGE-OLD-QQR-EJS"
   oSkin:TabStop := .T.
   oSkin:create()
   oSkin:ApplyOptions := nOR(xtpSkinApplyColors,xtpSkinApplyMetrics)
   oSkin:AutoApplyNewThreads := .T.
   oSkin:AutoApplyNewWindows := .T.
   oSkin:callMethod("LoadSkin","Office2007.cjstyles", "")
#ENDIF

*  oDlg:CreateToolbar(ReBarSmallHeight,"DXE_RBAR.EXE")
*  oDlg:CreateToolbar(ReBarLargeHeight,"DXE_RBAR.EXE")
   oDlg:CreateToolbar(48,"DXE_RBAR.EXE")

   aSize := oDlg:drawingArea:CurrentSize()
   aSize[1] += 1
   aSize[2] += 1
   oDlg:drawingArea:SetSize(aSize)

   CenterControl(oDlg)
   oDlg:Show()

   SetAppFocus( oDlg )

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

#IFDEF UseSkin
   oSkin:callMethod("RemoveAllWindows")
   oSkin:Destroy()
#ENDIF
   oDlg:destroy()
   SET ALTER TO

RETURN

PROCEDURE MyResize(aOldSize,aNewSize,oSelf,oDlg)
LOCAL nHeight := ReBarSmallHeight
LOCAL aChild  := {}
LOCAL i,iMax
LOCAL aBtnSize

   IF aOldSize[1] == 0 .AND. aOldSize[2] == 0               // was minimize
      aOldSize := aNewSize                                  // New Size

   ELSEIF aNewSize[1] == 0 .OR. aNewSize[2] == 0            // is now minimized
      RETURN

   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN
   ENDIF                                                    // same Size

   oSelf:lockUpdate(.T.)

   aChild := oSelf:Childlist()
   iMax := LEN(aChild)
   FOR i := 1 TO iMax
      IF aChild[i]:isDerivedFrom( "DXE_Rebar")
         //
         // one Band Line
         //
*        nHeight := aChild[i]:ROWHEIGHT(i)
         //
         // all Band Lines
         //
         nHeight := aChild[i]:Rebarheight

         aChild[i]:setPos({0,aNewSize[2]-nHeight})
         aChild[i]:setSize( {aNewSize[1],nHeight})
         //
         // damit wird ein Toolbar Chevron Menu angepasst ( nur 1 x hier ntig )
         //
*         aChild[i]:MinimizeBand(1)
*         aChild[i]:MaximizeBand(1)

      ENDIF
   NEXT

   oSelf:lockUpdate(.F.)
   oSelf:invalidateRect()

RETURN

CLASS TbForm FROM XbpDialog
   EXPORTED:
      VAR oRebar
      VAR oToolbar
      VAR oFontName
      VAR oFontSize

      METHOD init
      METHOD create
ENDCLASS

METHOD TbForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {2,-3}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {340,276}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {332,250}
   ENDIF
RETURN self

METHOD TbForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

CLASS TbDialog FROM TbForm
   EXPORTED:
      METHOD init
      METHOD create
      METHOD CreateToolbar()
ENDCLASS

METHOD TbDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::TbForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD TbDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::TbForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD TbDialog:CreateToolbar(nHeight,cDLL)
LOCAL aSize   := ::DrawingArea:CurrentSize()
LOCAL hModule
LOCAL oButton
LOCAL aFonts
LOCAL aFontNames
LOCAL aFontSizes
LOCAL lExact
LOCAL nCont,nLen
LOCAL aPos    := {2,0}
LOCAL aParts  := {}
LOCAL aItem   := {}
LOCAL oGroup
LOCAL oStatic
LOCAL oBtn
LOCAL nColor
LOCAL aBtnSize

DEFAULT nHeight TO ReBarSmallHeight

   IF VALTYPE(nHeight) = "N"
      aPos[2]  := aSize[2] -nHeight
      aSize[2] := nHeight
   ELSE
      Msgbox("Error Parameter"+VAR2CHAR(nHeight))
      RETURN self
   ENDIF

   IF ValType(cDLL) == "C"
      hModule := GetModuleHandleA( cDLL )
   ELSE
      hModule := GetModuleHandleA( 0 )
   ENDIF

   ::oRebar    := DXE_ReBar():New(::DrawingArea,,aPos,aSize,,.T.)
#IFDEF UseColor
  ::oRebar:useVisualStyle := .F.
#ENDIF
   ::oRebar:create()
**1**   ::oRebar:setColorBG(XBPSYSCLR_TRANSPARENT)


#IFDEF UseDXE
** ::oToolbar  := DXE_Toolbar():New( ::oRebar,,{0,0},{aSize[1],nHeight},,.T.)
   ::oToolbar  := DXE_Toolbar():New(::DrawingArea,,{0,0},{aSize[1]/2,nHeight})
* ::oToolbar:useVisualStyle := .F.
#ELSE
*  ::oToolbar  := XbpToolbar():New( ::oRebar,,{0,0},{0,nHeight},,.T.)
   ::oToolbar  := XbpToolbar():New(::DrawingArea,,{0,0},{0,nHeight})
#ENDIF

   IF ::oToolbar:isDerivedFrom( "DXE_Toolbar")
*     ::oToolbar:textAlign   := XBPALIGN_RIGHT
      ::oToolbar:wrappable    := .F.                // hier REBAR -> Chevron
*      ::oToolbar:appearance   := XBP_APPEARANCE_FLAT
      ::oToolbar:appearance   := XBP_APPEARANCE_3D  // or XBP_APPEARANCE_FLAT
      ::oToolbar:style        := XBPTOOLBAR_STYLE_FLAT
   ENDIF
   ::oToolbar:create()

   IF ::oToolbar:isDerivedFrom( "XbpToolbar")
      ::oToolbar:textAlign    := XBPALIGN_BOTTOM
*     ::oToolbar:textAlign    := XBPALIGN_RIGHT
      ::oToolbar:wrappable    := .F.                // hier REBAR -> Chevron
*     ::oToolbar:appearance   := XBP_APPEARANCE_FLAT
      ::oToolbar:style        := XBPTOOLBAR_STYLE_FLAT
      ::oToolbar:BorderStyle  := XBPFRAME_RECT
      ::oToolbar:lNORESIZE    := .T.                // is CCS_NORESIZE
   ENDIF

   IF ::oToolbar:isDerivedFrom( "DXE_Toolbar")
      ::oToolbar:buttonRClick    := {|oButton| HandleItemRClick(oButton)}

      ::oToolbar:buttonClick := {|oButton| HandlebuttonClick(oButton) }

   ELSE
      ::oToolbar:buttonClick := {|oButton| MsgBox("Knopf [" + ;
                          LTRIM(STR(oButton:index ))+" "+ ;
                           Var2Char(oButton:caption)+ ;
                          "] angeklickt!")   }
   ENDIF

   ::oToolbar:ButtonMenuClick := {|oButton| HandleItemClick(oButton)}

   //
   // load System Icon.
   // must be first
   //
*   IF nHeight = ReBarLargeHeight
       ::oToolbar:loadImageSet( XBPTOOLBAR_STDIMAGES_LARGE )
*   ELSE
*    ::oToolbar:loadImageSet( XBPTOOLBAR_STDIMAGES_SMALL )
*   ENDIF

   ::oToolbar:showToolTips    := .T.

   oBtn := ::oToolbar:addItem("new"     ,STD_IMAGE_FILENEW   ) // Neue Datei

   IF oBtn:isDerivedFrom( "DXE_ToolbarButton")
      oBtn:activate := {||Msgbox("new","Codeblock")}
   ENDIF

   ::oToolbar:addItem("open"    ,STD_IMAGE_FILEOPEN,,,,,,,, {||Msgbox("open","Codeblock")} ) // Datei ffnen
   ::oToolbar:addItem("save"    ,STD_IMAGE_FILESAVE  ) // Datei speichern
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("copy"    ,STD_IMAGE_COPY      ) // Kopieren
   ::oToolbar:addItem("paste"   ,STD_IMAGE_PASTE     ) // Einfgen
   ::oToolbar:addItem("cut"     ,STD_IMAGE_CUT       ) // Ausschneiden
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("del"     ,STD_IMAGE_DELETE    ) // Lschen
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("print"   ,STD_IMAGE_PRINT     ) // Drucken
   ::oToolbar:addItem("view"    ,STD_IMAGE_PRINTPRE  ) // Druckvorschau
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("find"    ,STD_IMAGE_FIND      ) // Suchen
   ::oToolbar:addItem("replace" ,STD_IMAGE_REPLACE   ) // Ersetzen
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("redo"    ,STD_IMAGE_REDO      ) // Wiederholen
   ::oToolbar:addItem("undo"    ,STD_IMAGE_UNDO      ) // Rckgngig machen
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   oBtn := ::oToolbar:addItem("proprty" ,STD_IMAGE_PROPERTIES,,,,XBPTOOLBAR_BUTTON_DROPDOWN) // Einstellungen
   oBtn:addItem( "Eintrag #1", "ITEM1" )
   oBtn:addItem( "Eintrag #2", "ITEM2" )
   oBtn:addItem( "Eintrag #3", "ITEM3" )
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("?"       ,STD_IMAGE_HELP      ) // Hilfe
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   //
   // XbpComboBox()
   //
   ::oFontName         := XbpComboBox():new(::oRebar, , {  8,-150}, {232,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
*   ::oFontName         := XbpComboBox():new(::DrawingArea,,{0,-150}, {0,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
   ::oFontName:tabstop := .T.
   ::oFontName:border  := .F.
   ::oFontName:create()

   aFonts := XbpFont():new( ::DrawingArea:lockPS() ):list()
      ::DrawingArea:unlockPS()
      aFontNames:= {}
      AEval( aFonts, {|o| IF( AScan( aFontNames, o:familyName ) == 0, ;
                              AAdd( aFontNames, o:familyName ), nil ) } )

      lExact:= Set( _SET_EXACT, .T. )
      aFontNames:= ASort( aFontNames )
      Set( _SET_EXACT, lExact )

      nLen:= Len( aFontNames )
      FOR nCont:= 1 TO nLen
         ::oFontName:addItem( aFontNames[ nCont ] )
      NEXT
   ::oFontName:setdata("Arial")

   //
   // XbpComboBox() oFontSize
   //
   ::oFontSize         := XbpComboBox():new(::oRebar, , {244,-150}, { 56,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
*   ::oFontSize         := XbpComboBox():new(::DrawingArea, , {244,-150}, { 0,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
   ::oFontSize:type    := XBPCOMBO_DROPDOWNLIST
   ::oFontSize:tabstop := .T.
   ::oFontSize:border  := .F.
   ::oFontSize:create()

   aFontSizes:= { '8', '10', '12', '14', '18', '24', '36' }
   nLen:= Len( aFontSizes )
   FOR nCont:= 1 TO nLen
      ::oFontSize:addItem( aFontSizes[ nCont ] )
   NEXT

   ::oFontSize:setdata("10")
   ::oFontSize:itemSelected := {|u1,u2,oSelf| Msgbox(oSelf:getItem( oSelf:getData()[1]) ) }

/****************************************************************************
*
* Syntax
*
* o:AddBand()
*
*   oXbPart    XbPart or Parent of XbParts in a Group
*   cCaption   Caption
*  +aUseSize   use only for special Construction
*   nFixWide   minimum Wide before -> resize other Rebar
*   hDLL       Resource-DLL if used
*   hbmBack    Background Image for Rebar
*   nHide      hide Rebar
*   nGrip      Gripper to move Rebar
*   nColor     Backgound Color Rebar / Toolbar Chevron Menu
*
****************************************************************************/

#IFDEF UseColor
*  nColor := AutomationTranslateColor(GraMakeRGBColor({255,242,229}),.F.)
   nColor := AutomationTranslateColor(GraMakeRGBColor({202,228,254}),.F.)
#ELSE
   nColor := NIL
#ENDIF

   ::oReBar:AddBand(::oToolbar            ,;   //   oXbPart
                    "Toolbar"             ,;   //   cCaption
                    {10*nHeight,nHeight}  ,;   //  +aUseSize
                    100                   ,;   //   nFixWide
                    NIL                   ,;   //   hDLL
                    NIL                   ,;   //   hbmBack
                    RBBS_HIDETITLE        ,;   //   nHide
                    RBBS_GRIPPERALWAYS    ,;   //   nGrip
                    nColor )                   //   nColor


   ::oReBar:AddBand(::oFontName           ,;   //   oXbPart
                    ""                    ,;   //   cCaption
                                          ,;   // leer lassen wegen Listbox Teil
                    100                   ,;   //   nFixWide
                    NIL                   ,;   //   hDLL
                    NIL                   ,;   //   hbmBack
                    RBBS_HIDETITLE        ,;   //   nHide
                    RBBS_GRIPPERALWAYS    ,;   //   nGrip
                    nColor )                   //   nColor


   ::oReBar:AddBand(::oFontSize           ,;   //   oXbPart
                    ""                    ,;   //   cCaption
                                          ,;   // leer lassen wegen Listbox Teil
                    56                    ,;   //   nFixWide
                    NIL                   ,;   //   hDLL
                    NIL                   ,;   //   hbmBack
                    RBBS_HIDETITLE        ,;   //   nHide
                    RBBS_GRIPPERALWAYS    ,;   //   nGrip
                    nColor )                   //   nColor


   IF ::oToolbar:isDerivedFrom( "DXE_Toolbar")
      //
      // for Rebar Chevron when using DXE_Toolbar
      //
      ::oToolbar:lUseRebar := .T.                // -> BTNS_AUTOSIZE
   ENDIF

   SetappWindow(::oRebar)
   SetappFocus(::oRebar)

RETURN

PROCEDURE HandleItemClick( oButton )

   DO CASE
      CASE oButton:Key == "ITEM1"
         MsgBox( "Drop-down-Meneintrag #1 ausgewhlt!" )
      CASE oButton:Key == "ITEM2"
         MsgBox( "Es wurde Eintrag #2 angeklickt." )
      CASE oButton:Key == "ITEM3"
         MsgBox( "Dieses Mal war es Meneintrag #3." )
   ENDCASE
RETURN

PROCEDURE HandleItemRClick( oButton )
LOCAL aRc := {0,0,0,0}

*  IF VALTYPE(oButton:activate) = "B"
*      EVAL(oButton:activate)
*     RETURN
*  ENDIF

   IF oButton:isDerivedFrom( "DXE_ToolbarButton")
      aRc[1] := oButton:left
      aRc[2] := oButton:top
      aRc[3] := oButton:right
      aRc[4] := oButton:bottom
   ENDIF

   Msgbox( "caption : "+VAR2CHAR(oButton:caption )+CRLF+;
           "enabled : "+VAR2CHAR(oButton:enabled )+CRLF+;
           "index   : "+VAR2CHAR(oButton:index   )+CRLF+;
           "key     : "+VAR2CHAR(oButton:key     )+CRLF+;
           "visible : "+VAR2CHAR(oButton:visible )+CRLF+;
           "activate: "+VAR2CHAR(oButton:activate)+CRLF+;
           "Type    : "+VAR2CHAR(oButton         )+CRLF+;
           "Child   : "+VAR2CHAR(oButton:Childlist() )+CRLF+;
           "Size    : "+VAR2CHAR(aRc) )
RETURN

PROCEDURE HandlebuttonClick(oButton)
LOCAL oChild

   IF VALTYPE(oButton:activate)="B"
      EVAL(oButton:activate)

   ELSEIF !EMPTY( oButton:Childlist() )

      oChild := oButton:Childlist()[1]
      IF oChild:isDerivedFrom("XbpComboBox")
         SetAppFocus(oChild)
         keybd_event( VK_F4, 0, 0, 0 )
         keybd_event( VK_F4, 0, KEYEVENTF_KEYUP, 0 )
      ENDIF

   ELSE
      MsgBox("Knopf [" + ;
              LTRIM(STR(oButton:index ))+" "+ ;
               Var2Char(oButton:caption)+ ;
              "] angeklickt!")
   ENDIF
RETURN


FUNCTION keybd_event( nVk, nScan, nFlags, nExtraInfo )

STATIC keybd_event
   IF keybd_event = NIL
      keybd_event := DllPrepareCall( "user32.dll", DLL_STDCALL, "keybd_event" )
   ENDIF
RETURN DllExecuteCall( keybd_event, nVk, nScan, nFlags, nExtraInfo )


STATIC PROCEDURE onDummy()
LOCAL iMax := PCount()
LOCAL i
LOCAL cText := ""
LOCAL xValue

   FOR i := 1 TO iMax -1
      cText += Var2Char( PValue( i ) ) + CHR(9)
   NEXT
   cText += Var2Char( PValue( iMax ) )

   SET CONSOLE OFF
   SET ALTER ON

   ? cText

   SET ALTER OFF
   SET CONSOLE ON

RETURN



//EOF
/////