
#include "xbp.ch"
#include "Appevent.ch"
#include "common.ch"
#include "GRA.ch"

#IFDEF UseDXE
   #include "dxe_Rbar.ch"
   #include "DLL.ch"
   DLLFUNCTION GetModuleHandleA( cModule ) USING STDCALL FROM KERNEL32.DLL
#ENDIF

#DEFINE UseColor  .T.

#define XBP_LAYOUT_TEXTLEFT         (XBPALIGN_LEFT+XBPALIGN_HCENTER)
#define XBP_LAYOUT_TEXTTOP          (XBPALIGN_TOP+XBPALIGN_VCENTER)
#define XBP_LAYOUT_TEXTBOTTOM       (XBPALIGN_BOTTOM+XBPALIGN_HCENTER)
#define XBP_LAYOUT_TEXTRIGHT        (XBPALIGN_RIGHT+XBPALIGN_VCENTER)

PROCEDURE appsys ; return
// ---------------------------------------------------------------------------

PROCEDURE Main()
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg

   SET DATE GERMAN
   SET CENTURY ON
   SET ALTER TO LOGFILE.TXT

   //
   oDlg := TbDialog():New(AppDesktop(),,{0,0}, {580,400},,.F.)

   oDlg:taskList := .T.
   oDlg:title    := "native Rebar"
   oDlg:icon     := 1
   oDlg:close    := {|p1,p2,oo| PostAppEvent(xbeP_Quit,,,oo) }
   oDlg:drawingArea:resize := {| aOldSize, aNewSize, oSelf | MyResize(aOldSize,aNewSize,oSelf,oDlg)  }
   oDlg:drawingArea:clipChildren := .T.
   oDlg:Create()
#IFDEF UseColor
*  oDlg:drawingArea:setcolorBG( GraMakeRGBColor({255,242,229}) )
   oDlg:drawingArea:setcolorBG( GraMakeRGBColor({202,228,255}) )
#ENDIF

   CenterControl(oDlg)

   oDlg:CreateToolbar(ReBarSmallHeight,"RECOMBO.EXE")
*  oDlg:CreateToolbar(ReBarLargeHeight,"RECOMBO.EXE")

   oDlg:Show()
   SetAppFocus( oDlg )

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

   oDlg:destroy()
   SET ALTER TO

RETURN


PROCEDURE MyResize(aOldSize,aNewSize,oSelf,oDlg)
LOCAL nHeight := ReBarSmallHeight
LOCAL aChild  := {}
LOCAL i,iMax

   IF aOldSize[1] == 0 .AND. aOldSize[2] == 0               // was minimize
      aOldSize := aNewSize                                  // New Size

   ELSEIF aNewSize[1] == 0 .OR. aNewSize[2] == 0            // is now minimized
      RETURN

   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN
   ENDIF                                                    // same Size

   oSelf:lockUpdate(.T.)

   aChild := oSelf:Childlist()
   iMax := LEN(aChild)
   FOR i := 1 TO iMax
      IF aChild[i]:isDerivedFrom( "DXE_Rebar")
         //
         // one Band Line
         //
*        nHeight := aChild[i]:ROWHEIGHT(i)
         //
         // all Band Lines
         //
         nHeight := aChild[i]:Rebarheight

         aChild[i]:setPos({0,aNewSize[2]-nHeight})
         aChild[i]:setSize( {aNewSize[1],nHeight},.T.)

         //
         // damit wird ein Toolbar Chevron Menu angepasst
         //
*         aChild[i]:MinimizeBand(1)
*         aChild[i]:MaximizeBand(1)
      ENDIF
   NEXT

   oSelf:lockUpdate(.F.)
   oSelf:invalidateRect()

RETURN


CLASS TbForm FROM XbpDialog
   EXPORTED:
      VAR oRebar
      VAR oFontName
      VAR oFontSize

      METHOD init
      METHOD create
ENDCLASS

METHOD TbForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {2,-3}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {340,276}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {332,250}
   ENDIF
   ::XbpDialog:taskList := .T.

RETURN self

METHOD TbForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

CLASS TbDialog FROM TbForm
   EXPORTED:
      METHOD init
      METHOD create

      METHOD CreateToolbar()

ENDCLASS

METHOD TbDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::TbForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD TbDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::TbForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD TbDialog:CreateToolbar(nHeight,cDLL)
LOCAL aSize   := ::DrawingArea:CurrentSize()
LOCAL hModule
LOCAL oButton
LOCAL aFonts
LOCAL aFontNames
LOCAL aFontSizes
LOCAL lExact
LOCAL nCont,nLen
LOCAL aPos    := {2,0}
LOCAL oGroup
LOCAL oBtn
LOCAL nNo
LOCAL aBtnPos := {0,0}
LOCAL cString
LOCAL nColor
LOCAL oBMP

DEFAULT nHeight TO ReBarSmallHeight

   IF VALTYPE(nHeight) = "N"
      aPos[2] := aSize[2] -nHeight
      aSize[2] := nHeight
   ELSE
      Msgbox("Error Parameter"+VAR2CHAR(nHeight))
      RETURN self
   ENDIF

   IF ValType(cDLL) == "C"
      hModule := GetModuleHandleA( cDLL )
   ELSE
      hModule := GetModuleHandleA( 0 )
   ENDIF

   ::oRebar    := DXE_ReBar():New(::DrawingArea,,aPos,aSize,,.T.)
#IFDEF UseColor
   ::oRebar:useVisualStyle := .F.
#ENDIF
   ::oRebar:create()
*   ::oRebar:setColorBG(XBPSYSCLR_TRANSPARENT)

   //
   // put all Button on same parent
   //
   oGroup   := XbpStatic():New(  ::oRebar,,{0,0},{12*nHeight,nHeight})
   oGroup:create()

   FOR nNo := 1 TO 12

      oBMP := XbpBitmap():new():create()
      oBMP:load(,nNo+1000)

#IFDEF UseImageButton
      oBtn := XbpImageButton():New( oGroup,,aBtnPos,{nHeight,nHeight})
      oBtn:Caption      := "F"+LTRIM(STR(nNo))
      oBtn:Image        := oBMP
      oBtn:CaptionLayout:= XBP_LAYOUT_TEXTBOTTOM
      oBtn:TextAlign    := XBPALIGN_HCENTER
      oBtn:ImageAlign   := XBPALIGN_HCENTER
      oBtn:DrawMode     := XBP_DRAW_OWNER
#ELSE
      oBtn  := XbpPushButton():new(oGroup,,aBtnPos,{nHeight,nHeight})
*     oBtn:caption := "F"+LTRIM(STR(nNo))
      oBtn:caption := BMP2BMP(oBMP,{nHeight,nHeight})
#ENDIF
      oBtn:create()

      cString := "{|| Msgbox( 'Pushbutton "+LTRIM(STR(nNo)) +"','Codeblock' ) }"
      oBtn:activate:= &cString

      oBtn:rbClick := {| aPos, uNIL, oSelf | HandleItemRClick( oSelf ) }

      aBtnPos[1] += nHeight+1
   NEXT


   //
   // XbpComboBox() oFontName
   //
   ::oFontName         := XbpComboBox():new(::oRebar, , {  8,-150}, {232,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
   ::oFontName:type    := XBPCOMBO_DROPDOWNLIST
   ::oFontName:tabstop := .T.
   ::oFontName:border  := .F.
   ::oFontName:create()


   aFonts := XbpFont():new( ::DrawingArea:lockPS() ):list()
   ::DrawingArea:unlockPS()
   aFontNames:= {}
   AEval( aFonts, {|o| IF( AScan( aFontNames, o:familyName ) == 0, ;
                           AAdd( aFontNames, o:familyName ), nil ) } )
   lExact:= Set( _SET_EXACT, .T. )
   aFontNames:= ASort( aFontNames )
   Set( _SET_EXACT, lExact )
   nLen:= Len( aFontNames )
   FOR nCont:= 1 TO nLen
      ::oFontName:addItem( aFontNames[ nCont ] )
   NEXT

   ::oFontName:setdata("Arial")
   ::oFontName:itemSelected := {|u1,u2,oSelf| Msgbox(oSelf:getItem(oSelf:getData()[1])) }


   //
   // XbpComboBox() oFontSize
   //
   ::oFontSize         := XbpComboBox():new(::oRebar, , {244,-150}, { 56,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
   ::oFontSize:type    := XBPCOMBO_DROPDOWNLIST
   ::oFontSize:tabstop := .T.
   ::oFontSize:border  := .F.
   ::oFontSize:create()

   aFontSizes:= { '8', '10', '12', '14', '18', '24', '36' }
   nLen:= Len( aFontSizes )
   FOR nCont:= 1 TO nLen
      ::oFontSize:addItem( aFontSizes[ nCont ] )
   NEXT

   ::oFontSize:setdata("10")
   ::oFontSize:itemSelected := {|u1,u2,oSelf| Msgbox(oSelf:getItem( oSelf:getData()[1]) ) }


/****************************************************************************
*
* Syntax
*
* o:AddBand()
*
*   oXbPart    XbPart or Parent of XbParts in a Group
*   cCaption   Caption
*  +aUseSize   use only for special Construction
*   nFixWide   minimum Wide befor -> resize other Rebar
*   hDLL       Resource-DLL if used
*   hbmBack    Background Image for Rebar
*   nHide      hide Rebar
*   nGrip      Gripper to move Rebar
*   nColor     Backgound Color Rebar / Toolbar Chevron Menu
*
****************************************************************************/

#IFDEF UseColor
*  nColor := AutomationTranslateColor(GraMakeRGBColor({255,242,229}),.F.)
   nColor := AutomationTranslateColor(GraMakeRGBColor({202,228,255}),.F.)
#ELSE
   nColor := NIL
#ENDIF


   ::oReBar:AddBand(oGroup                ,; //   oXbPart
                    ""                    ,; //   cCaption
                                          ,; //  +aUseSize
                    aSize[1]-(3*100)      ,; //   nFixWide
                    NIL                   ,; //   hDLL
                    NIL                   ,; //   hbmBack
                    RBBS_HIDETITLE        ,; //   nHide
                    RBBS_GRIPPERALWAYS    ,; //   nGrip
                    nColor )                 //   nColor

   ::oReBar:AddBand(::oFontName           ,; //   oXbPart
                    "Font"                ,; //   cCaption
                                          ,; //  +aUseSize
                    100                   ,; //   nFixWide
                    NIL                   ,; //   hDLL
                    NIL                   ,; //   hbmBack
                    RBBS_HIDETITLE        ,; //   nHide
                    RBBS_GRIPPERALWAYS    ,; //   nGrip
                    nColor )                 //   nColor

   ::oReBar:AddBand(::oFontSize           ,; //   oXbPart
                    "Size"                ,; //   cCaption
                                          ,; //  +aUseSize
                    56                    ,; //   nFixWide
                    NIL                   ,; //   hDLL
                    NIL                   ,; //   hbmBack
                    RBBS_HIDETITLE        ,; //   nHide
                    RBBS_GRIPPERALWAYS    ,; //   nGrip
                    nColor )                 //   nColor

   SetappWindow(::oRebar)
   SetappFocus(::oRebar)

RETURN

STATIC FUNCTION BMP2BMP(oBMP,aXbpSize)
LOCAL oHuge
LOCAL oTiny
LOCAL oPS
LOCAL oRet

   IF aXbpSize[2] > 0
      oHuge := oBMP
      oPS := XbpPresSpace():new():Create()
      //Create a small bitmap to fit in our XbpStatic
      oTiny := XbpBitmap():New():Create()
      oTiny:Make(aXbpSize[1],aXbpSize[2])
      oTiny:presSpace(oPS)
      //Copie and resize the huge bitmap to the small bitmap
*     oHuge:Draw(oPS,{0,0,aXbpSize[1],aXbpSize[2]},,,GRA_BLT_BBO_IGNORE)
      oHuge:Draw(oPS,{0,0,aXbpSize[1],aXbpSize[2]},,,4)
      oRet := oTiny
   ELSE
      oRet := oBMP
   ENDIF

RETURN oRet


PROCEDURE HandleItemRClick( oBtn )

   IF  oBtn:isDerivedFrom("XbpPushButton")

      Msgbox( "caption : "+VAR2CHAR(oBtn:caption )+CRLF+;
              "activate: "+VAR2CHAR(oBtn:activate)+CRLF+;
              "dllName : "+VAR2CHAR(oBtn:dllName )+CRLF+;
              "Type    : "+VAR2CHAR(oBtn         )+CRLF+;
              "Size    : "+VAR2CHAR(oBtn:Currentsize()),"o:rbClick" )

   ELSEIF oBtn:isDerivedFrom("XbpImageButton")

      Msgbox( "caption : "+VAR2CHAR(oBtn:caption )+CRLF+;
              "activate: "+VAR2CHAR(oBtn:activate)+CRLF+;
              "dllName : "+VAR2CHAR(oBtn:dllName )+CRLF+;
              "Image   : "+VAR2CHAR(oBtn:Image   )+CRLF+;
              "Type    : "+VAR2CHAR(oBtn         )+CRLF+;
              "Size    : "+VAR2CHAR(oBtn:Currentsize()),"o:rbClick"  )
  ENDIF
RETURN

//EOF
/////