#include "dxe_sbar.ch"
#include "common.ch"
#include "xbp.ch"
#include "OS.ch"
#include "GRA.ch"

#define StatbarHigh              24

PROCEDURE CreateStatusbar(oDlg,oSbar)
LOCAL oDa,aPos
LOCAL aTmp
LOCAL aSize := {0,0}
LOCAL cHex
LOCAL oPanel
LOCAL oPanel2

   oDa   := oDlg:drawingArea
   aPos  := {0,0}

   aTmp  := oDa:Currentsize()

   aSize[1] := aTmp[1]
   aSize[2] := StatbarHigh                       // in DXE_SBAR.CH

   //
   // create on Dialog (!). see resize later.
   //
   oSbar := DXE_Statbar():New(oDlg,,aPos,aSize,,.F.)
   //
   // set before o:create if need
   //
   oSbar:sizeGrip := .T.

   //
   // default UsevisualStyle := .F. !!!
   // need for oPanel:bevel ( default XBPSTATUSBAR_BEVEL_INSET )
   //
   // p.s. using UsevisualStyle := .T. -> all Flat
   //
   oSbar:UsevisualStyle := .T.

   //
   // now with ownerdraw
   //
   oSbar:DrawMode := XBP_DRAW_OWNER
   oSbar:drawItem := {| oPS, aInfo, oSelf | Colordraw(oPS, aInfo, oSelf) }

   oSbar:create()

   //
   // after o:create()
   //
   IF oSbar:UsevisualStyle = .F.
      //
      // not RGB must be BGR
      //
*      cHex := "0x"+cByte2Hex(254)+;  // Blue
*                   cByte2Hex(254)+;  // Green
*                   cByte2Hex(076)    // Red

*      cHex := "0xFFFFFFFF"
*      cHex := "0x00000001"
*      cHex := "0x00000004"
*      cHex := "0xFF000000"
      //
      // does NOT work with Manifest and UsevisualStyle := .T. !!!
      //
      @user32:SendMessageA(oSbar:hStatusBar,SB_SETBKCOLOR, 0, &cHex )
   ENDIF

   oSbar:show()

   //
   // DblClick on Panel
   //
*  oSbar:panelDblClick := {|oPanel,uNil,oSelf| GetPanelAction(oPanel) }
   oSbar:panelClick    := {|oPanel,uNil,oSelf| GetPanelAction(oPanel) }

   //
   // not in Xbase++ XbpStatusbar()
   //
   oSbar:panelRBClick  := {|oPanel,uNil,oSelf| GetPanelInfo(oPanel) }

   //
   // use String only
   //
   // Additem(cCaption,xImage,cDLL,nStyle,cKey,    nMinWide,bBlock)
   //
   // only DXE_Statbar()
   //
   // nMinWide := Minimum Panel wide -> oPanel:minWidth
   // bBlock   := Codeblock Slot     -> oPanel:activate
   //
   // 1st Panel always expand to maximum
   //
   oSbar:additem("Click me"    ,1004,,,"TEXT",, {|| ProgressShow(1,oSbar) } )

   // 2nd Panel with nMinWide ( and Icon )
   oPanel := oSbar:additem("Hello world",,,,,80)
   oPanel:activate := {|| Lauftext(oSbar,2,"this is a long Text to scroll on Panel using Thread") }

   // 3rd Panel with nMinWide and Bitmap Resource 1001
   //
   // ! Note : oPanel2 else it switch "last" oPanel ???
   //
   oPanel := oSbar:additem("more"   ,1001,,,,50)
   oPanel:activate := {|| SwitchIcon(oSbar,3) }

   //
   // "spezial" with fix Size.
   //
   // does not use Icon
   //
   oSbar:additem("INSERT"   ,,, XBPSTATUSBAR_PANEL_INSERT   )

*  oSbar:additem("NUMLOCK"  ,,, XBPSTATUSBAR_PANEL_NUMLOCK  )
   oPanel := oSbar:additem()
   oPanel:style       := XBPSTATUSBAR_PANEL_NUMLOCK
   oPanel:alignment   := XBPALIGN_HCENTER
   oPanel:autoSize    := XBPSTATUSBAR_AUTOSIZE_CONTENTS
   oPanel:width       -= 40

   oSbar:additem("CAPSLOCK" ,,, XBPSTATUSBAR_PANEL_CAPSLOCK )
*  oSbar:additem("SCROLL"   ,,, XBPSTATUSBAR_PANEL_SCROLL   )

   oPanel := oSbar:additem("DATE"     ,,, XBPSTATUSBAR_PANEL_DATE      )
   oPanel:activate := {|| OpenControl() }

   oPanel := oSbar:additem("TIME"     ,,, XBPSTATUSBAR_PANEL_TIME      )
   oPanel:activate := {|| OpenControl() }
   //
   // obsolet : Populate() now internal
   //
   // oSbar:Populate()

   // when use Dialog as Parent
   // resize o:drawingArea so {0,0} is over Statusbar
   //
   oDa:SetPosAndSize( { 0, StatbarHigh }, { aTmp[ 1 ], aTmp[ 2 ] - StatbarHigh } )

RETURN

PROCEDURE MyResize(aOldSize, aNewSize, oSelf,oSbar)
LOCAL aChild := {}

   IF aOldSize[1] == 0 .AND. aOldSize[2] == 0               // was minimize
      aOldSize := aNewSize                                  // New Size

   ELSEIF aNewSize[1] == 0 .OR. aNewSize[2] == 0            // is now minimized
      RETURN

   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN
   ENDIF                                                    // same Size

   oSelf:lockUpdate(.T.)

   aChild := oSelf:Childlist()
   //
   // only 1 PushButton
   //
   IF aChild[1]:isDerivedFrom("XbpPushbutton")
      aChild[1]:setSize({aNewSize[1]-45,aNewSize[2]-112})
   ENDIF

   //
   // Statusbar new Size
   //
   // no need too:Populate() it any more when WM_SIZE change
   //
   oSbar:setSize({aNewSize[1],StatbarHigh})
   //
   // obsolet : Populate() now internal
   //
   // oSbar:Populate()

   oSelf:lockUpdate(.F.)
   oSelf:invalidateRect()

RETURN

PROCEDURE GetPanelAction(oPanel)

   IF VALTYPE(oPanel:activate) = "B"
      EVAL(oPanel:activate)
   ELSE
      Msgbox(oPanel:caption,"Panel "+LTRIM(STR(oPanel:index)))
   ENDIF

RETURN

PROCEDURE GetPanelInfo(oPanel)

    msgbox("alignment  "+CHR(9)+VAR2CHAR(oPanel:alignment  )+CRLF+;
           "autosize   "+CHR(9)+VAR2CHAR(oPanel:autosize   )+CRLF+;
           "bevel      "+CHR(9)+VAR2CHAR(oPanel:bevel      )+CRLF+;
           "caption    "+CHR(9)+VAR2CHAR(oPanel:caption    )+CRLF+;
           "enabled    "+CHR(9)+VAR2CHAR(oPanel:enabled    )+CRLF+;
           "image      "+CHR(9)+VAR2CHAR(oPanel:image      )+CRLF+;
           "index      "+CHR(9)+VAR2CHAR(oPanel:index      )+CRLF+;
           "key        "+CHR(9)+VAR2CHAR(oPanel:key        )+CRLF+;
           "left       "+CHR(9)+VAR2CHAR(oPanel:left       )+CRLF+;
           "minWidth   "+CHR(9)+VAR2CHAR(oPanel:minWidth   )+CRLF+;
           "style      "+CHR(9)+VAR2CHAR(oPanel:style      )+CRLF+;
           "tooltipText"+CHR(9)+VAR2CHAR(oPanel:tooltipText)+CRLF+;
           "visible    "+CHR(9)+VAR2CHAR(oPanel:visible    )+CRLF+;
           "width      "+CHR(9)+VAR2CHAR(oPanel:width      )+CRLF+;
           "internal  :"                                    +CRLF+;
           "hStatusbar "+CHR(9)+VAR2CHAR(oPanel:hStatusbar )+CRLF+;
           "cDll       "+CHR(9)+VAR2CHAR(oPanel:cDll       )+CRLF+;
           "activate   "+CHR(9)+VAR2CHAR(oPanel:activate   )+CRLF+;
           "Spezial    "+CHR(9)+VAR2CHAR(oPanel:Spezial    ))
RETURN

PROCEDURE ProgressShow(nNo,oSbar)
LOCAL oThread
   IF nNo > 0 .AND. nNo <= oSbar:NumItems()
      oThread := Thread():new()
      oThread:start( {|| _ProgressShow(nNo,oSbar,oThread) } )
   ENDIF
RETURN

PROCEDURE _ProgressShow(nNo,oSbar,oThread)
LOCAL oProgress
LOCAL i
LOCAL aPP      := {}
LOCAL aRect    := {0,0,0,0}
LOCAL aPOS     := {0,0}
LOCAL aSIZE    := {0,0}
LOCAL xMax     := 100                     // or Lastrec()
LOCAL nEvery   := INT(xMax/100)
LOCAL xScale   := xMax*nEvery             // Scale to 100%

DEFAULT nNo TO 0

   //
   // get Panel Dimension
   //
   aRect := oSbar:GetPanelRect(nNo)       // NOT Zero-based

   aPOS[1]  := aRect[1]
   aPOS[2]  := aRect[2]
   aSIZE[1] := aRect[3]-aRect[1]-2
   aSIZE[2] := aRect[4]-aRect[2]-2

   //
   // create Statusbar
   //
   oProgress := DXE_ProgressBar():New( oSbar,, aPOS, aSIZE,aPP )
   //
   // NEED visual Style and XP Manifest !!!
   //
   oProgress:UseVisualStyle   := .T.
   oProgress:UsePercent       := .T.
   oProgress:Create()
   oProgress:show()

   //
   // assign after create
   //
   oProgress:Style            := PBS_SMOOTH
   oProgress:Minimum          := 0
   oProgress:Maximum          := xMax
   oProgress:nScaleMax        := xScale
   oProgress:Increment        := nEvery

   oProgress:Border           := .F.

   FOR i := 1 TO xMax
      oProgress:SetData( i )
      SLEEP(10)
   NEXT

   oProgress:destroy()

   oThread:setInterval(NIL)
   oThread := NIL

RETURN

PROCEDURE OpenControl()
   IF OS( OS_FAMILY ) == "WINNT"
      RUNSHELL( "Shell32,Control_RunDLL Timedate.cpl,@0,02", GETENV( "SYSTEMROOT" ) + "\SYSTEM32\RUNDLL32.EXE", .T. )
   ELSE
      RUNSHELL( "Shell32,Control_RunDLL Timedate.cpl,@0,02", "C:\WINDOWS\RUNDLL32.EXE", .T. )
   ENDIF
RETURN

PROCEDURE SwitchIcon(oSbar,nNo)
STATIC lLast := .T.
   //
   // One-based Index
   //
   IF nNo > 0 .AND. nNo <= oSbar:NumItems()

      IF lLast = .T.
         lLast := .F.
         oSbar:SetNewIcon(nNo,1000)
      ELSE
         lLast := .T.
         oSbar:SetNewIcon(nNo,1001)
      ENDIF
   ENDIF
RETURN

PROCEDURE SetPanelText(nNo,cText,oSbar)
LOCAL oPanel
   //
   // One-based Index
   //
   IF nNo > 0 .AND. nNo <= oSbar:NumItems()
      oPanel := oSbar:GetItem(nNo)        // NOT Zero-based
      oPanel:caption := cText
   ENDIF
RETURN

PROCEDURE Lauftext(oSbar,nNo,cText)
   IF nNo > 0 .AND. nNo <= oSbar:NumItems()
      oSbar:Scrolltext(nNo,cText)
   ENDIF
RETURN


FUNCTION Colordraw(oPS, aInfo, oSelf)
LOCAL nItem    := aInfo[ XBP_DRAWINFO_ITEM   ] // Index des Elements, das neu gezeichnet werden muss
LOCAL nAction  := aInfo[ XBP_DRAWINFO_ACTION ] // Aktion, die die Nachricht xbeP_DrawItem auslste
LOCAL nState   := aInfo[ XBP_DRAWINFO_STATE  ] // Aktueller Anzeigestatus des Elements
LOCAL aRect    := aInfo[ XBP_DRAWINFO_RECT   ] // Ausgaberechteck fr die Zeichenoperation

LOCAL cText
LOCAL aPrev
LOCAL aSAttrs  := Array( GRA_AS_COUNT )
LOCAL aAAttrs  := Array( GRA_AA_COUNT )
LOCAL nXDest   := aInfo[XBP_DRAWINFO_RECT][1]
LOCAL nYDest   := aInfo[XBP_DRAWINFO_RECT][2]
LOCAL nWidth   := aInfo[XBP_DRAWINFO_RECT][3]
LOCAL nHeight  := aInfo[XBP_DRAWINFO_RECT][4]

LOCAL oPanel

*  cText := aInfo[5]            // extra element ... NOT stable ???

*ONDUMMY( nItem )

   IF EMPTY(nItem)
tone(1234)
      RETURN .F.
   ENDIF

   IF nItem < 0
tone(1234)
      RETURN .F.
   ENDIF

   oPanel := oSelf:GetItem( nItem +1 )
   cText  := oPanel:Caption

   DO CASE
      CASE oPanel:style = XBPSTATUSBAR_PANEL_CAPSLOCK ; IF( oSelf:lCAPSLOCK, cText := "CAPS ON"  , cText := "CAPS OFF"  )
      CASE oPanel:style = XBPSTATUSBAR_PANEL_NUMLOCK  ; IF( oSelf:lNUMLOCK , cText := "NUM ON"   , cText := "NUM OFF"   )
      CASE oPanel:style = XBPSTATUSBAR_PANEL_INSERT   ; IF( oSelf:lINSERT  , cText := "INS ON"   , cText := "INS OFF"   )
      CASE oPanel:style = XBPSTATUSBAR_PANEL_SCROLL   ; IF( oSelf:lSCROLL  , cText := "SCROLL ON", cText := "SCROLL OFF")
      CASE oPanel:style = XBPSTATUSBAR_PANEL_DATE     ; cText := DTOC(DATE())
      CASE oPanel:style = XBPSTATUSBAR_PANEL_TIME     ; cText := TIME()
   OTHERWISE
      cText    := oPanel:Caption
   ENDCASE

/**************************
*
* ist nItem Zero-based ???
*

   IF nItem < 0
      RETURN .T.

*   ELSEIF nItem =  4
*      IF EMPTY(CtoD(cText))
*         RETURN .T.
*      ENDIF

   ELSEIF nItem =  4

   ELSEIF nItem > 1 .AND. nItem < 4
      DO CASE
         CASE "INS ON"     $ cText
         CASE "NUM ON"     $ cText
         CASE "CAPS ON"    $ cText
         CASE "SCROLL ON"  $ cText
         CASE "INS OFF"    $ cText
         CASE "NUM OFF"    $ cText
         CASE "CAPS OFF"   $ cText
         CASE "SCROLL OFF" $ cText
      OTHERWISE
         RETURN .T.
      ENDCASE
   ENDIF

**************************/

   //
   // this calculation is different to Xbase++ !!!
   //
   // it is while i "simulate" oPS with ViewPoint 0,0
   // to use GRA Function with Bitmap Transfer to hDC
   //
   nWidth   := nWidth  - nXDest
   nHeight  := nHeight - nYDest
   nXDest   := 0
   nYDest   := 0

   aAAttrs[GRA_AA_COLOR] := XBPSYSCLR_3DFACE
   GraSetAttrArea( oPS, aAAttrs )
   GraBox( oPS, {nXDest,nYDest}, {nWidth,nHeight}, GRA_FILL )

   DO CASE
      CASE cText = "INS ON"     ; aSAttrs[GRA_AS_COLOR] := GRA_CLR_BLACK
      CASE cText = "NUM ON"     ; aSAttrs[GRA_AS_COLOR] := GRA_CLR_BLACK
      CASE cText = "CAPS ON"    ; aSAttrs[GRA_AS_COLOR] := GRA_CLR_BLACK
      CASE cText = "SCROLL ON"  ; aSAttrs[GRA_AS_COLOR] := GRA_CLR_BLACK

      CASE cText = "INS OFF"    ; aSAttrs[GRA_AS_COLOR] := GRA_CLR_DARKGRAY
      CASE cText = "NUM OFF"    ; aSAttrs[GRA_AS_COLOR] := GRA_CLR_DARKGRAY
      CASE cText = "CAPS OFF"   ; aSAttrs[GRA_AS_COLOR] := GRA_CLR_DARKGRAY
      CASE cText = "SCROLL OFF" ; aSAttrs[GRA_AS_COLOR] := GRA_CLR_DARKGRAY
   OTHERWISE
      aSAttrs[GRA_AS_COLOR] := XBPSYSCLR_WINDOWTEXT
   ENDCASE

   aSAttrs[ GRA_AS_HORIZALIGN ]  := GRA_HALIGN_RIGHT
   aSAttrs[ GRA_AS_VERTALIGN ]   := GRA_VALIGN_HALF
   aSAttrs[ GRA_AS_ANGLE ] := { 1, 0 }
   aPrev := GraSetAttrString( oPS, aSAttrs )

   GraCaptionStr(oPS, {nXDest,nYDest } ,;
                      {nWidth,nHeight} ,;
                       cText           ,;
                       XBPALIGN_VCENTER  )

   GraSetAttrString( oPS, aPrev )

RETURN .T.

*
* EOF
*