//////////////////////////////////////////////////////////////////////
//
//  RTF.PRG
//
//  Copyright:
//   Alaska Software, (c) 2002-2006. Alle Rechte vorbehalten.
//
//  Inhalt:
//
//////////////////////////////////////////////////////////////////////

#include "Xbp.ch"
#include "Appevent.ch"
#include "DLL.CH"

#PRAGMA LIBRARY( "XPPUI2.LIB" )

#define CRLF   Chr(13) + Chr(10)

******************************************************************************
* Main Prozedur zum Testen des Formulars
******************************************************************************
PROCEDURE Main()

 LOCAL oForm
 LOCAL nEvent
 LOCAL mp1 := NIL, mp2 := NIL, oXbp := NIL

 SET ALTER TO LOGFILE.TXT

   oForm := RTFForm():new( SetAppWindow() )
   oForm:visible       := .F.
   oForm:minSize       := {400,200}
   oForm:create()
   oForm:close         := {|| AppQuit()}
   oForm:SetInputFocus := {|| SetAppFocus(oForm:oRTF)}

   CenterControl( oForm )

   oForm:show()
   SetAppFocus( oForm:oRTF )

   nEvent := xbe_None
   DO WHILE nEvent != xbeP_Quit
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:handleEvent( nEvent, mp1, mp2 )
   ENDDO

 SET ALTER TO

RETURN

******************************************************************************
* berladene AppSys()-Prozedur. Verhindert die Erzeugung des Standard-
* XbpCrt-Fensters.
******************************************************************************
PROCEDURE AppSys
RETURN


******************************************************************************
* Beenden der Anwendung
******************************************************************************
PROCEDURE AppQuit()

  IF ConfirmBox(SetAppWindow(),                   ;
                "Are you sure you want to quit?", ;
                "Editor Sample Application" ) == XBPMB_RET_OK
     PostAppEvent( xbeP_Quit )
  ENDIF

RETURN


******************************************************************************
* Von der Darstellungsklasse abgeleitete Klasse zur Implementierung der
* Programmlogik. Die Instanzvariablen der einzelnen Objekte sind in der
* Klasse _RtfForm deklariert.
******************************************************************************
CLASS RtfForm FROM _RtfForm
   EXPORTED:
      VAR cFileName
      METHOD Init
      METHOD Create
      METHOD GetFileName
      METHOD Refresh
      METHOD LoadFile
      METHOD Resize

      METHOD ToolbarResize
      METHOD ToolButtonClick
ENDCLASS

******************************************************************************
* Formular initialisieren
******************************************************************************
METHOD RtfForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   * Execute method of the super class
   ::_RtfForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::Title := "Editor-Beispiel"

   * Preparations of callback slots
   ::oFontName:ItemSelected := { || ::oRtf:SelFontName := Trim(::oFontName:XbpSLE:GetData()) }
   ::oFontSize:ItemSelected := { || ::oRtf:SelFontSize := Val(::oFontSize:XbpSLE:GetData()+".00") }

#IFDEF UseDXE
   ::oFontName:Cargo := "oFontName"
   ::oFontSize:Cargo := "oFontSize"
#ENDIF

   ::Close                  := { || ::Destroy() }
   ::oToolbar:resize        := { |aOld,aNew| ::ToolbarResize(aOld,aNew) }

RETURN self


******************************************************************************
* Systemresourcen anfordern
******************************************************************************
METHOD RtfForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

 LOCAL aFonts, aSizes, aFontNames
 LOCAL oButton, oPanel
 LOCAL nTmp
 LOCAL bOldBlock
 LOCAL oError

   // Erzeugen des Editor-Dialogs. Zur Behandlung eines
   // moegl. Fehlers, z.B. durch eine fehlenden Komponente,
   // wird BEGIN/END SEQUENCE verwendet.
   bOldBlock := ErrorBlock( {|e| Break(e)} )
   BEGIN SEQUENCE
     ::_RtfForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   RECOVER USING oError
     IF oError:subCode == 6500
        MsgBox( "Fehler beim Erzeugen eines ActiveX-Steuerelements. Bitte stellen Sie sicher," + CRLF +;
                "dass MS Common Controls 6.0 auf Ihrem Computer installiert sind.", ;
                "Editor-Beispiel" )
        QUIT
      ENDIF
   END SEQUENCE
   ErrorBlock( bOldBlock )

   //
   // Hinzufuegen der Toolbar-Buttons
   //
   ::oToolbar:LoadImageSet( XBPTOOLBAR_STDIMAGES_SMALL )
*  ::oToolbar:LoadImageSet( XBPTOOLBAR_STDIMAGES_LARGE )
   ::oToolbar:ButtonClick := {|oButton| ::ToolButtonClick(oButton)}

   oButton        := ::oToolbar:AddItem()
   oButton:Image := STD_IMAGE_FILEOPEN
   oButton:Key   := "Oeffnen"
   oButton        := ::oToolbar:AddItem()
   oButton:Image := STD_IMAGE_FILESAVE
   oButton:Key   := "Speichern"
   oButton        := ::oToolbar:AddItem()
   oButton:Image := STD_IMAGE_PRINT
   oButton:Key   := "Drucken"

   oButton        := ::oToolbar:AddItem()
   oButton:Style := XBPTOOLBAR_BUTTON_SEPARATOR

   oButton        := ::oToolbar:AddItem()
   oButton:Style := XBPTOOLBAR_BUTTON_PLACEHOLDER
#IFDEF UseDXE
   oButton:width := 232
   //
   // do NOT SetPos() while Parent have change to Toolbar Button
   //
*   ::oFontName:setPos( {oButton:Left, oButton:Top} )
#ELSE
   oButton:width := ::oFontName:CurrentSize()[1]
   ::oFontName:setPos( {oButton:Left, oButton:Top - oButton:Height} )
#ENDIF

   oButton        := ::oToolbar:AddItem()
   oButton:Style := XBPTOOLBAR_BUTTON_SEPARATOR

   oButton        := ::oToolbar:AddItem()
   oButton:Style := XBPTOOLBAR_BUTTON_PLACEHOLDER
#IFDEF UseDXE
   oButton:width := 56
   //
   // do NOT SetPos() while Parent have change to Toolbar Button
   //
*   ::oFontSize:setPos( {oButton:Left, oButton:Top} )
#ELSE
   oButton:width := ::oFontSize:CurrentSize()[1]
   ::oFontSize:setPos( {oButton:Left, oButton:Top - oButton:Height} )
#ENDIF

   oButton        := ::oToolbar:AddItem()
   oButton:Style := XBPTOOLBAR_BUTTON_SEPARATOR

   oButton        := ::oToolbar:AddItem()
   oButton:Image := 100
   oButton:Key   := "Fett"
   oButton        := ::oToolbar:AddItem()
   oButton:Image := 101
   oButton:Key   := "Kursiv"
   oButton        := ::oToolbar:AddItem()
   oButton:Image := 102
   oButton:Key   := "Unterstrichen"

   oButton        := ::oToolbar:AddItem()
   oButton:Style := XBPTOOLBAR_BUTTON_SEPARATOR

   oButton        := ::oToolbar:AddItem()
   oButton:Image := 103
   oButton:Style := XBPTOOLBAR_BUTTON_BUTTONGROUP
   oButton:Key   := "Links"
   oButton        := ::oToolbar:AddItem()
   oButton:Image := 104
   oButton:Style := XBPTOOLBAR_BUTTON_BUTTONGROUP
   oButton:Key   := "Zentriert"
   oButton        := ::oToolbar:AddItem()
   oButton:Image := 105
   oButton:Style := XBPTOOLBAR_BUTTON_BUTTONGROUP
   oButton:Key   := "Rechts"

   oButton        := ::oToolbar:AddItem()
   oButton:Style := XBPTOOLBAR_BUTTON_SEPARATOR

   oButton        := ::oToolbar:AddItem()
   oButton:Image := 106
   oButton:Key   := "Liste"

   //
   // Hinzufuegen der Statusbar-Panels
   //
   oPanel          := ::oStatusbar:GetItem( 1 )
   oPanel:AutoSize := XBPSTATUSBAR_AUTOSIZE_SPRING

   oPanel         := ::oStatusbar:AddItem()
   oPanel:Style    := XBPSTATUSBAR_PANEL_CAPSLOCK
   oPanel:Alignment:= XBPALIGN_HCENTER
   oPanel:AutoSize := XBPSTATUSBAR_AUTOSIZE_CONTENTS
   oPanel:Width    -= 50

   oPanel         := ::oStatusbar:AddItem()
   oPanel:Style   := XBPSTATUSBAR_PANEL_NUMLOCK
   oPanel:Alignment:= XBPALIGN_HCENTER
   oPanel:AutoSize:= XBPSTATUSBAR_AUTOSIZE_CONTENTS
   oPanel:Width    -= 50

   oPanel         := ::oStatusbar:AddItem()
   oPanel:Style   := XBPSTATUSBAR_PANEL_INSERT
   oPanel:Alignment:= XBPALIGN_HCENTER
   oPanel:AutoSize:= XBPSTATUSBAR_AUTOSIZE_CONTENTS
   oPanel:Width    -= 50

   //
   // Initialisieren der Font-Liste
   //
   aFonts := XbpFont():New(::LockPS()):List()
   ::UnlockPS()
   aFontNames := {}
   AEval( aFonts, { |o| IF(AScan(aFontNames,o:FamilyName)==0, ;
                           AAdd(aFontNames,o:FamilyName), NIL) } )
   ASort( aFontNames )
   AEval( aFontNames, { |c| ::oFontName:AddItem( c ) } )

   aSizes := { "6", "8", "10", "11", "12", "14", "16", "18", "20", ;
               "22", "24", "32", "36", "48", "52", "72" }
   AEval( aSizes, { |c| ::oFontSize:AddItem( c ) } )

   ::oRtf:SelChange := { || ::Refresh() }
   ::Refresh()

RETURN self

******************************************************************************
* Dialogelemente aktualisieren
******************************************************************************
METHOD RtfForm:Refresh()

 LOCAL xTmp
 LOCAL nCol
 LOCAL nLine

   //
   // Anzeigen der aktuellen Zeile und Spalte in der Statuszeile
   //
   nLine := ::oRTF:GetLineFromChar( ::oRTF:SelStart )
   nCol  := ::oRTF:SelStart - ::oRTF:GetLineStart( nLine )

   xTmp  := "Zeile: " + LTrim( Str(nLine +1) ) + ;
            "   Spalte: " + LTrim( Str(nCol +1) )

   ::oStatusbar:GetItem(1):Caption := xTmp

   //
   // Updaten der Toolbarelemente abhaengig von der aktuellen
   // Auswahl. Zu beachten ist, dass fuer nicht eindeutige
   // Kriterien der Wert NIL in der entsprechenden Instanz-
   // variable stehen kann! Enthaelt die aktuelle Auswahl
   // beispielweise sowohl kursiven als auch nicht-kursiven
   // Text, enthaelt die ":SelItalic"-Instanzvariable NIL.
   //
   xTmp := ::oRtf:SelFontName
   IF Empty(xTmp) == .T.
      ::oFontName:XbpSle:SetData( "" )
   ELSE
      ::oFontName:XbpSle:SetData( xTmp )
   ENDIF
   xTmp := ::oRtf:SelFontSize
   IF Empty(xTmp) == .T.
      ::oFontSize:XbpSle:SetData( "" )
   ELSE
      ::oFontSize:XbpSle:SetData( AllTrim( Str( Int(xTmp) ) ) )
   ENDIF

   xTmp := ::oRtf:SelBold
   IF xTmp == NIL
      ::oToolbar:GetItem("Fett"):MixedState := .T.
   ELSE
      ::oToolbar:GetItem("Fett"):MixedState := .F.
      ::oToolbar:GetItem("Fett"):Pressed    := xTmp
   ENDIF

   xTmp := ::oRtf:SelItalic
   IF xTmp == NIL
      ::oToolbar:GetItem("Kursiv"):MixedState := .T.
   ELSE
      ::oToolbar:GetItem("Kursiv"):MixedState := .F.
      ::oToolbar:GetItem("Kursiv"):Pressed    := xTmp
   ENDIF

   xTmp := ::oRtf:SelUnderline
   IF xTmp == NIL
      ::oToolbar:GetItem("Unterstrichen"):MixedState := .T.
   ELSE
      ::oToolbar:GetItem("Unterstrichen"):MixedState := .F.
      ::oToolbar:GetItem("Unterstrichen"):Pressed    := xTmp
   ENDIF

   xTmp := ::oRtf:SelAlignment
   IF xTmp == NIL
      ::oToolbar:GetItem("Links"):MixedState   := .T.
      ::oToolbar:GetItem("Rechts"):MixedState  := .T.
      ::oToolbar:GetItem("Zentriert"):MixedState := .T.
   ELSE
      ::oToolbar:GetItem("Links"):MixedState   := .F.
      ::oToolbar:GetItem("Rechts"):MixedState  := .F.
      ::oToolbar:GetItem("Zentriert"):MixedState := .F.
      IF xTmp == XBPRTF_ALIGN_LEFT
         ::oToolbar:GetItem("Links"):Pressed := .T.
      ELSEIF xTmp == XBPRTF_ALIGN_RIGHT
         ::oToolbar:GetItem("Rechts"):Pressed := .T.
      ELSEIF xTmp == XBPRTF_ALIGN_CENTER
         ::oToolbar:GetItem("Zentriert"):Pressed := .T.
      ENDIF
   ENDIF

   xTmp := ::oRtf:SelBullet
   IF xTmp == NIL
      ::oToolbar:GetItem("Liste"):MixedState := .T.
   ELSE
      ::oToolbar:GetItem("Liste"):MixedState := .F.
      ::oToolbar:GetItem("Liste"):Pressed    := xTmp
   ENDIF

RETURN self


******************************************************************************
* Ein Werkzeugknopf wurde ausgewhlt. Zugeordnetes Kommando ausfhren.
******************************************************************************
METHOD RtfForm:ToolButtonClick( oButton )

   DO CASE
      CASE oButton:Key == "Oeffnen"
           ::oRtf:LoadFile(::GetFileName(.T.))
      CASE oButton:Key == "Speichern"
           ::oRtf:SaveFile(::GetFileName(.F.))
      CASE oButton:Key == "Drucken"
           ::oRtf:Print()
      CASE oButton:Key == "Fett"
           ::oRtf:SelBold := IF(Empty(::oRtf:SelBold),.T.,.F.)
      CASE oButton:Key == "Kursiv"
           ::oRtf:SelItalic := IF(Empty(::oRtf:SelItalic),.T.,.F.)
      CASE oButton:Key == "Unterstrichen"
           ::oRtf:SelUnderline := IF(Empty(::oRtf:SelUnderline),.T.,.F.)
      CASE oButton:Key == "Links"
           ::oRtf:SelAlignment := XBPRTF_ALIGN_LEFT
      CASE oButton:Key == "Zentriert"
           ::oRtf:SelAlignment := XBPRTF_ALIGN_CENTER
      CASE oButton:Key == "Rechts"
           ::oRtf:SelAlignment := XBPRTF_ALIGN_RIGHT
      CASE oButton:Key == "Liste"
          ::oRtf:SelBullet := IF(Empty(::oRtf:SelBullet),.T.,.F.)
   ENDCASE

   ::Refresh()

RETURN self


******************************************************************************
* Dateinamen ermitteln
******************************************************************************
METHOD RtfForm:GetFileName(lOpen)

   LOCAL oDlg := XbpFileDialog():New():Create(self)

   IF lOpen
      ::cFileName := oDlg:Open("*.rtf")
      IF ! File( ::cFileName )
        ::cFileName := ""
        MsgBox( "File existiert nicht", "Fehler" )
      ENDIF
   ELSE
      ::cFileName := oDlg:SaveAs(::cFileName)
   ENDIF
   oDlg:Destroy()
   IF Empty( ::cFileName )
      ::cFileName := ""
   ENDIF

RETURN ::cFileName


******************************************************************************
* Datei laden
******************************************************************************
METHOD RtfForm:LoadFile(cFile)

   ::cFileName := cFile
   ::oRtf:LoadFile(::cFileName)

RETURN ::cFileName


******************************************************************************
* Grsse des Dialogs wurde gendert. Child-Controls anpassen und neu
* positionieren.
******************************************************************************
METHOD RtfForm:Resize(aOldSize, aNewSize)

 LOCAL oButton
 LOCAL nTmp
 LOCAL nSLEY
 LOCAL cTmp
 LOCAL aSizeDA   := ::CalcClientRect( {0,0,aNewSize[1],aNewSize[2]} )
 LOCAL aSizeTBar := ::oToolbar:CurrentSize()
 LOCAL aSizeSBar := ::oStatusbar:CurrentSize()

   aSizeDA := {aSizeDA[3] - aSizeDA[1],aSizeDA[4] - aSizeDA[2]}

   ::oToolbar:SetSize( {aSizeDA[1], aSizeTBar[2]} )
   ::oToolbar:SetPos( {0, aSizeDA[2]-aSizeTBar[2]} )

   oButton := ::oToolbar:GetItem("Speichern")

   nSLEY   := ::oFontSize:CurrentSize()[2] - (::oFontSize:ListBoxSize()[2] -2)
   nTmp    := ::oToolbar:CurrentSize()[2]  - nSLEY
   nTmp    -= (::oFontSize:ListBoxSize()[2]- 2)
   nTmp    -= abs(oButton:Height - nSLEY) /2

   onDummy("Resize",nSLEY,::oToolbar:CurrentSize()[2],::oFontSize:ListBoxSize()[2],oButton:Height)


   cTmp := ::oFontName:XbpSle:GetData()
   //
   // original have Toolbar as Parent
   //
   aPos := ::oFontName:CurrentPos()
   #IFDEF UseDXE
      onDummy("oFontName",::oFontName:Setparent(),aPos,nTmp)
      //
      // DXE use ToolbarButton as Parent -> {0,y}
      //
      ::oFontName:SetPos( {0,nTmp} )
   #ELSE
      ::oFontName:SetPos( {aPos[1],nTmp} )
   #ENDIF
   ::oFontName:XbpSle:SetData( cTmp )

   cTmp := ::oFontSize:XbpSle:GetData()
   //
   // original have Toolbar as Parent
   //
   aPos := ::oFontSize:CurrentPos()
   #IFDEF UseDXE
      onDummy("oFontSize",::oFontSize:Setparent(),aPos,nTmp)
      //
      // DXE use ToolbarButton as Parent -> {0,y}
      //
      ::oFontSize:setPos( {0,nTmp} )
   #ELSE
      ::oFontSize:setPos( {aPos[1],nTmp} )
   #ENDIF
   ::oFontSize:XbpSle:SetData( cTmp )

   ::oStatusbar:SetSize( { aSizeDA[1], aSizeSBar[2] } )
   ::oRtf:SetSize( { aSizeDA[1], aSizeDA[2]-aSizeTBar[2]-aSizeSBar[2] } )

RETURN self


******************************************************************************
* Gre der Toolbar hat sich gendert. Neu anordnen der Dialogelemente.
******************************************************************************
METHOD RtfForm:ToolbarResize(aOldSize, aNewSize)

 LOCAL aSize

   IF aOldSize[2] != aNewSize[2]
      aSize := ::currentSize()
      ::Resize( aSize, aSize )
   ENDIF

RETURN self

#IFDEF UseDXE
DLLFUNCTION GetModuleHandleA( cModule ) ;
       USING STDCALL                           ;
       FROM  KERNEL32.DLL
#ENDIF

STATIC PROCEDURE onDummy()
LOCAL iMax := PCount()
LOCAL i
LOCAL cText := ""
LOCAL xValue

   FOR i := 1 TO iMax -1
      cText += Var2Char( PValue( i ) ) + CHR(9)
   NEXT
   cText += Var2Char( PValue( iMax ) )

   SET CONSOLE OFF
   SET ALTER ON

   ? cText

   SET ALTER OFF
   SET CONSOLE ON

RETURN

//EOF
/////