//////////////////////////////////////////////////////////////////////
//
//  _RTF.PRG
//
//  Copyright:
//      Alaska Software, (c) 2002-2006. Alle Rechte vorbehalten.
//
//  Inhalt:
//
//////////////////////////////////////////////////////////////////////

#ifndef _RTFFORM_
#define _RTFFORM_

#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

CLASS _RtfForm FROM XbpDialog
   EXPORTED:
      VAR editControls

      * Contained control elements
      VAR oToolbar
      VAR oFontSize
      VAR oFontName
      VAR oStatusbar
      VAR oRTF

      METHOD init
      METHOD create
ENDCLASS

******************************************************************************
* Formular initialisieren
******************************************************************************
METHOD _RTFForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {599,253}, ;
           aSize    TO {600,395}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )
   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:drawingArea:clipChildren := .T.
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "RTFForm"

   ::editControls := {}

#IFDEF UseDXE
   ::oToolbar   := DXE_ToolBar():new( ::drawingArea, , {0,336}, {592,40-16} ,, .T. )
   ::oToolbar:borderStyle  := XBPFRAME_NONE      // all other give WS_BORDER
   ::oToolbar:textAlign    := XBPALIGN_BOTTOM    // or XBPALIGN_RIGHT
   ::oToolbar:appearance   := XBP_APPEARANCE_3D  // or XBP_APPEARANCE_FLAT
   ::oToolbar:wrappable    := .F.
   ::oToolbar:showToolTips := .T.
   ::oToolbar:lNORESIZE    := .T.                // is CCS_NORESIZE

#ELSE
   ::oToolbar   := XbpToolBar():new( ::drawingArea, , {0,336}, {592,40} ,, .T. )
#ENDIF

  ::oFontName  := XbpComboBox():new( ::oToolbar, , {8,-150}, {232,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
*  ::oFontName  := XbpComboBox():new()
   ::oFontName:tabstop := .T.

  ::oFontSize  := XbpComboBox():new( ::oToolbar, , {244,-150}, {56,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )
*   ::oFontSize  := XbpComboBox():new()
   ::oFontSize:tabstop := .T.

#IFDEF UseDXE
   ::oStatusbar := DXE_StatBar():new( ::drawingArea, , {0,0}, {592,28} ,, .T. )
#ELSE
   ::oStatusbar := XbpStatusBar():new( ::drawingArea, , {0,0}, {592,28} ,, .T. )
#ENDIF

   ::oRTF       := XbpRTF():new( ::drawingArea, , {0,28}, {592,308} ,, .T. )

RETURN self


******************************************************************************
* Systemresourcen anfordern
******************************************************************************
METHOD _RTFForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oToolbar:create()
   ::oToolbar:Style := XBPTOOLBAR_STYLE_FLAT
   ::oToolbar:BorderStyle := XBPFRAME_RECT

  ::oFontName:create( ::oToolbar)
*   ::oFontName:create( ::oToolbar, , {8,-150}, {232,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )

  ::oFontSize:create( ::oToolbar)
*   ::oFontSize:create( ::oToolbar, , {244,-150}, {56,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } )

   ::oStatusbar:create()
   ::oStatusbar:Caption := "Panel"

   ::oRTF:create()
   ::oRTF:Scrollbars := XBP_SCROLLBAR_HORIZ+XBP_SCROLLBAR_VERT


RETURN self

#endif

//EOF
/////